#include<iostream>
#include<bits/stdc++.h>
using namespace std;
const int MAXN=1000000;
int n;
int ans=-1;
pair<int,int> point[MAXN];
pair<int,int> tree[MAXN*4];
// first=max v intervala
// second=min v intervala
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
void make_tree(int i, int l, int r)
{
    if(l==r)
    {
        tree[i].first=point[l].second;
        tree[i].second=point[l].second;
        return;
    }
    int m=(l+r)/2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
    tree[i].first=max(tree[i*2].first , tree[i*2+1].first);
    tree[i].second=min(tree[i*2].second , tree[i*2+1].second);
    return;
}
pair<int,int>query(int i, int l, int r, int ql, int qr)
{
    int m=(l+r)/2;
    if(ql==l && qr==r) return tree[i];
    if(qr<=m) return query(i*2,l,m,ql,qr);
    if(ql>m) return query(i*2+1,m+1,r,ql,qr);
    pair<int,int>p1=query(i*2,l,m,ql,m);
    pair<int,int>p2=query(i*2+1,m+1,r,m+1,qr);
    pair<int,int>p3;
    p3.first=max(p1.first , p2.first);
    p3.second=min(p1.second , p2.second);
    return p3;
}
bool cmp(pair<int, int> x, pair<int,int> y)
{
    if(x.first<=y.first) return 1;
    else return 0;
}
void read()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>point[i].first>>point[i].second;
    }
    sort(point+1,point+1+n,cmp);
}
void check(int x, int y)
{
    int x1,y1;
    for(int i=x;i>=1;i--)
    {
        if(point[i].first!=point[x].first)
        {
            x1=i;
            break;
        }
    }
    for(int i=y;i<=n;i++)
    {
        if(point[i].first!=point[y].first)
        {
            y1=i;
            break;
        }
    }
    int a_ans=max(point[x].first , point[y].first)-min(point[x].first , point[y].first);
    pair<int,int>p1=query(1,1,n,1,x1);
    pair<int,int>p2=query(1,1,n,y1,n);
    int bmax=max(p1.first,p2.first);
    int bmin=min(p1.second, p2.second);
    int b_ans=bmax-bmin;
    int tans=a_ans+b_ans;
    if(ans==-1 || tans<ans) ans=tans;
    return;
}
void solve()
{
    make_tree(1,1,n);
    for(int i=1;i<=n;i++)
    {
        for(int j=i;j<=n;j++)
        {
            check(i,j);
        }
    }
    cout<<ans<<'\n';
}
int main()
{
    speed();
    read();
    solve();
    return 0;
}
