#include <bits/stdc++.h>
#define x first
#define y second
#pragma GCC optimize ("O3")
using namespace std;

const int maxn = 2000006, inf = 1e9;
int n;
pair <int, int> points [maxn];
int maxr [maxn], minr [maxn];
int val1 [maxn], val2 [maxn], val3 [maxn], val4 [maxn];

/*int tree [maxn * 4][5];
void build (int l, int r, int pos){
    if (l == r){
        tree [pos][2] = val2 [l];
        tree [pos][3] = val3 [l];
        tree [pos][4] = val4 [l];
        return;
    }
    int mid = l + r >> 1;
    build (l, mid, pos << 1);
    build (mid + 1, r, pos << 1 | 1);
    for (int i = 2; i <= 4; i ++) tree [pos][i] = min (tree [pos << 1][i], tree [pos << 1 | 1][i]);
}
int query (int l, int r, int pos, int k, int ql, int qr){
    if (ql > r || qr < l) return inf;
    if (ql <= l && r <= qr) return tree [pos][k];
    int mid = l + r >> 1;
    return min (query (l, mid, pos << 1, k, ql, qr), query (mid + 1, r, pos << 1 | 1, k, ql, qr));
}*/

vector <pair <int, int> > sorted2, sorted3, sorted4;
int idx2, idx3, idx4;

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 1; i <= n; i ++) cin >> points [i].x >> points [i].y;
    minr [n + 1] = inf;
    val1 [n + 1] = points [n].x;
    for (int i = n; i > 0; i --){
        maxr [i] = max (maxr [i + 1], points [i].y);
        minr [i] = min (minr [i + 1], points [i].y);
        val1 [i] = points [i - 1].x;
        val2 [i] = maxr [i] + points [i - 1].x;
        val3 [i] = - minr [i] + points [i - 1].x;
        val4 [i] = maxr [i] - minr [i] + points [i - 1].x;
        sorted2.push_back (make_pair (val2 [i], i));
        sorted3.push_back ({val3 [i], i});
        sorted4.push_back ({val4 [i], i});
    }
    sort (sorted2.begin (), sorted2.end ());
    sort (sorted3.begin (), sorted3.end ());
    sort (sorted4.begin (), sorted4.end ());
    int ans = 1e9;
    int maxl = 0, minl = inf;
    int pos1 = n, pos2 = n;
    for (int i = 1; i <= n; i ++){
        /*int l = i, r = n;
        while (l < r){
            int mid = (l + r + 1) >> 1;
            if (maxr [mid] > maxl && minr [mid] < minl) l = mid;
            else r = mid - 1;
        }
        int pos1 = l;
        l = pos1, r = n;
        while (l < r){
            int mid = (l + r + 1) >> 1;
            if (maxr [mid] > maxl || minr [mid] < minl) l = mid;
            else r = mid - 1;
        }
        int pos2 = l;*/

        if (pos1 < i) pos1 = i;
        while (pos1 > i && (maxr [pos1] <= maxl || minr [pos1] >= minl)) pos1 --;
        if (pos2 < pos1) pos2 = pos1;
        while (pos2 > pos1 && maxr [pos2] <= maxl && minr [pos2] >= minl) pos2 --;

        /*int min1 = query (1, n, 1, 4, i + 1, pos1);
        int min2;
        if (maxr [pos2] > maxl) min2 = query (1, n, 1, 2, pos1 + 1, pos2);
        else min2 = query (1, n, 1, 3, pos1 + 1, pos2);
        int min3 = val1 [pos2 + 1];*/

        while (idx2 < n && sorted2 [idx2].second > pos2) idx2 ++;
        while (idx3 < n && sorted3 [idx3].second > pos2) idx3 ++;
        while (idx4 < n && sorted4 [idx4].second > pos1) idx4 ++;
        int min1 = sorted4 [idx4].first;
        int min2;
        if (maxr [pos2] > maxl) min2 = sorted2 [idx2].first;
        else min2 = sorted3 [idx3].first;
        int min3 = val1 [pos2 + 1];

        /*for (int j = i + 1; j <= pos1; j ++) min1 = min (min1, val4 [j]);
        if (maxr [pos2] > maxl) for (int j = pos1 + 1; j <= pos2; j ++) min2 = min (min2, val2 [j]);
        else for (int j = pos1 + 1; j <= pos2; j ++) min2 = min (min2, val3 [j]);
        min3 = val1 [pos2 + 1];*/

        if (pos1 > i) ans = min (ans, min1 - points [i].x);
        if (pos2 != pos1){
            if (maxr [pos2] > maxl) ans = min (ans, min2 - minl - points [i].x);
            else ans = min (ans, min2 + maxl - points [i].x);
        }
        ans = min (ans, max (0, maxl - minl) + min3 - points [i].x);
        maxl = max (maxl, points [i].y);
        minl = min (minl, points [i].y);

    }
    cout << ans << '\n';

}
