#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;
/// postavi granici i q zarqza
/// takava hubava jena razplakvash ti
/// den mporo den mporo tinakano
/// moi gelas se koito kaitahano

const int maxn = 3e5 + 3;
const int inf = 2e9 + 3;

int n, t;
int a[maxn];
int val[maxn];

void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];

    for (int i = 1; i <= a[n]; i++)
        val[i] = inf;

    cin >> t;
    for (int i = 1; i <= t; i++)
    {
        int pos;
        cin >> pos;
        cin >> val[pos];
    }
}

bool is[maxn];
vector <int> adj[maxn];
vector <int> rev_adj[maxn];
int deg[maxn];

void dfs(int ver)
{
    for (auto i: adj[ver])
    if (val[i] == inf)
    {
        val[i] = val[ver] + 1;
        dfs(i);
    }
}

void dfs2(int ver)
{
    for (auto i: rev_adj[ver])
    if (val[i] == inf)
    {
        val[i] = val[ver] - 1;
        dfs(i);
    }
}

void solve()
{
    for (int i = 2; i <= n; i++)
    for (int j = a[i]; j > a[i-1]; j--)
    is[j] = (i & 1);

    for (int i = 2; i <= a[n]; i++)
    {
        if (!is[i])
        {
            adj[i-1].push_back(i);
            rev_adj[i].push_back(i-1);
            deg[i]++;
        }

        else
        {
            adj[i].push_back(i-1);
            rev_adj[i-1].push_back(i);
            deg[i-1]++;
        }
    }

    queue <int> q;
    vector <int> order;

    for (int i = 1; i <= a[n]; i++)
    if (!deg[i])
    q.push(i);

    while (!q.empty())
    {
        auto ver = q.front();
        q.pop();

        order.push_back(ver);
        for (auto i: adj[ver])
        {
            deg[i]--;
            if (!deg[i])
            q.push(i);
        }
    }

    reverse(order.begin(), order.end());

    for (;;)
    {
        bool is = false;
        for (auto i: order)
            if (val[i] == inf)
        {
            is = true;
            break;
        }

        if (!is)
        break;

        vector <pair <int, int> > v;
        for (auto i: order)
        if (val[i] != inf)
        v.push_back({val[i], i});

        sort (v.begin(), v.end());
        reverse (v.begin(), v.end());

        for (auto i: v)
        dfs(i.second);

        v.clear();
        for (auto i: order)
        if (val[i] != inf)
        v.push_back({val[i], i});

        sort (v.begin(), v.end());
        reverse (v.begin(), v.end());

        for (auto i: v)
        {
            bool can = false;
            for (auto j: rev_adj[i.second])
                if (val[j] == inf)
            {
                val[j] = val[i.second] - 1;
                can = true;
                break;
            }

            if (can)
                break;
        }
    }

    int mins = inf, maxs = 0;
    for (int i = 1; i <= a[n]; i++)
    {
        mins = min(mins, val[i]);
        maxs = max(maxs, val[i]);
    }

    cout << (long long)maxs - (long long)mins << " " << 0 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
