#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;
struct pt{
    int x,y;
    bool operator <(pt a)const{
        return this->x<a.x;
    }
};
vector<pt>pts;
int rmq[1000005][32],rmq2[1000005][32];
int lmin[1000005],lmax[1000005];
int rmin[1000005],rmax[1000005];
int vals[1000005],vals2[1000005];
int logs[1000005];
int query(int a,int b){
    if(a==b){
        return rmq[a][0];
    }
    int log=logs[b-a+1];
    //cout<<"in: "<<a<<" "<<b<<" "<<log<<endl;
    if(vals[rmq[a][log]]<vals[rmq[b-(1<<log)+1][log]]){
        return rmq[a][log];
    }else{
        //cout<<b-(1<<log)+1;
        return rmq[b-(1<<log)+1][log];
    }
}
int n;
int lm;
int solve1(int cmax,int cmin,int cl){
    lm=max(lm,cl);
    while(lm>cl && rmax[lm]<=cmax && rmin[lm]>=cmin){
        lm--;
    }
    return lm;
}
int ll,lr;
int solve2(int cmax,int cmin,int cl){
    ll=max(ll,cl-1);
    while(ll>cl && rmin[ll]>=cmin){
        ll--;
    }
    //cout<<"maxes: "<<cmax<<" "<<cmin<<endl;
    while(rmax[lr]<cmax){
        lr--;
    }
    //cout<<"ls: "<<ll<<" "<<lr<<" "<<cl<<endl;
    if(lr<=cl || lr<ll){
        //cout<<"wtf"<<endl;
        return -1;
    }
    //cout<<"query"<<query(ll-2,lr-2)<<endl;
    return query(ll-1,lr-2)+1;
}
int solve3(int cmax,int cmin,int cl){
    lm=min(lm,cl);
    while(lm<cl && lmax[lm]<=cmax && lmin[lm]>=cmin){
        lm++;
    }
    return lm;
}
int solve4(int cmax,int cmin,int cl){
    ll=min(ll,cl+1);
    while(ll<cl && lmin[ll]>=cmin){
        ll++;
    }
    //cout<<"maxes: "<<cmax<<" "<<cmin<<endl;
    //cout<<"try: "<<lmax[lr]<<endl;
    while(lmax[lr]<cmax){
        lr++;
    }
    //cout<<"ls: "<<ll<<" "<<lr<<" "<<cl<<endl;
    if(lr>=cl || lr>ll){
        //cout<<"wtf"<<endl;
        return -1;
    }
    //cout<<"query"<<query(ll-2,lr-2)<<endl;
    return query(lr,ll-1)+1;
}
int main(){
    logs[0]=0;
    logs[1]=0;
    int last=1;
    for(int i=2;i<1000005;i++){
        logs[i]=logs[i-1];
        if(i==last*2){
            logs[i]++;
            last*=2;
        }
    }
    cin>>n;
    ll=n;
    lr=n;
    lm=n;
    for(int i=0;i<n;i++){
        int x,y;
        cin>>x>>y;
        pts.push_back({x,y});
    }
    //sort(pts.begin(),pts.end());
    /*for(int i=0;i<n;i++){
        rminq[i][0]=pts[i].y;
    }
    for(int j=1;j<22;j++){
        for(int i=0;i+(1<<j)<n;i++){
            rminq[i][j]=min(rminq[i][j-1],rminq[i+(1<<j)][j-1]);
        }
    }*/
    lmin[0]=rmin[n+1]=200000000;
    lmax[0]=rmax[n+1]=0;
    for(int i=1;i<=n;i++){
        lmin[i]=min(lmin[i-1],pts[i-1].y);
        lmax[i]=max(lmax[i-1],pts[i-1].y);
    }
    for(int i=n;i>0;i--){
        rmin[i]=min(rmin[i+1],pts[i-1].y);
        rmax[i]=max(rmax[i+1],pts[i-1].y);
    }
    for(int i=2;i<=n;i++){
        vals[i-2]=rmax[i]-(pts[n-1].x-pts[i-2].x);
        rmq[i-2][0]=i-2;
        //cout<<vals[i-2]<<" ";
    }
    //cout<<endl;
    for(int j=1;j<30;j++){
        for(int i=0;i+(1<<j)<=n-1;i++){
            //rminq[i][j]=min(rminq[i][j-1],rminq[i+(1<<j)][j-1]);
            if(vals[rmq[i][j-1]]<vals[rmq[i+(1<<(j-1))][j-1]]){
                rmq[i][j]=rmq[i][j-1];
            }else{
                rmq[i][j]=rmq[i+(1<<(j-1))][j-1];
            }
        }
    }
    for(int i=1;i<n;i++){
        vals2[i-1]=lmax[i]-(pts[i].x-pts[1].x);
        rmq2[i-1][0]=i-1;
        //cout<<vals[i-2]<<" ";
    }
    //cout<<endl;
    for(int j=1;j<30;j++){
        for(int i=0;i+(1<<j)<=n-1;i++){
            //rminq[i][j]=min(rminq[i][j-1],rminq[i+(1<<j)][j-1]);
            if(vals[rmq2[i][j-1]]<vals[rmq2[i+(1<<(j-1))][j-1]]){
                rmq2[i][j]=rmq2[i][j-1];
            }else{
                rmq2[i][j]=rmq2[i+(1<<(j-1))][j-1];
            }
        }
    }
    int opt=300000000;
    lmin[0]=rmin[n+1]=0;
    for(int i=2;i<=n;i++){
        int cmin=lmin[i-1],cmax=lmax[i-1];
        int r1=solve1(cmax,cmin,i);
        //cout<<i<<" "<<r1<<endl;
        opt=min(opt,cmax-cmin+pts[r1-1].x-pts[i-1].x);
        int r2=solve2(cmax,cmin,i);
        if(r2!=-1 && i<n && r2<n){
            //cout<<r2;
            int ans=rmax[r2+1]-lmin[i-1]+pts[r2-1].x-pts[i-1].x;
            //cout<<i<<" "<<r2<<" "<<ans<<endl;
            opt=min(opt,ans);
        }
    }
    ll=1;
    lr=1;
    lm=1;
    for(int i=n-1;i>=1;i--){
        int cmin=rmin[i+1],cmax=rmax[i+1];
        int r1=solve3(cmax,cmin,i);
        //cout<<i<<" "<<r1<<endl;
        opt=min(opt,cmax-cmin+pts[i-1].x-pts[r1-1].x);
        //cout<<cmax<<endl;
        int r2=solve4(cmax,cmin,i);
        //cout<<r2<<endl;
        if(r2!=-1 && i>1 && r2>0){
            //cout<<r2;
            int ans=lmax[r2-1]-rmin[i+1]+pts[i-1].x-pts[r2-1].x;
            //cout<<i<<" "<<r2<<" "<<ans<<endl;
            opt=min(opt,ans);
        }
    }
    cout<<opt<<endl;
    return 0;
}
