#include<bits/stdc++.h>
using namespace std;

const int nmax=3e5+42;

int hills,inp[nmax];

int f;
pair<int/*h*/,int/*forced?*/> forced[nmax];

long long at_least,at_most;

long long delta;

void run_up(int id_l,int id_r)
{
    int l=inp[id_l];
    int r=inp[id_r];

    if(forced[l].second)at_most=min(at_most,1LL*forced[l].first);

    if(forced[r].second)at_least=max(at_least,1LL*forced[r].first-delta);

    for(int j=l+1;j<r;j++)
        {
            if(forced[j].second)
            {
                at_most=min(at_most,1LL*forced[j].first+l-j);
                at_least=max(at_least,1LL*forced[j].first+r-j-delta);
            }
        }
}

void run_down(int id_l,int id_r)
{
    int l=inp[id_l];
    int r=inp[id_r];

    if(forced[l].second)at_least=max(at_least,1LL*forced[l].first-delta);

    if(forced[r].second)at_most=min(at_most,1LL*forced[r].first);

    for(int j=l+1;j<r;j++)
        {
            if(forced[j].second)
            {
                at_most=min(at_most,1LL*forced[j].first+j-r);
                at_least=max(at_least,1LL*forced[j].first-delta+j-l);
            }
        }
}

bool valid(long long cur)
{
    delta=cur;

    at_least=-2e9,at_most=2e9;

    for(int i=1;i<hills;i++)
        if(i%2==1)run_up(i,i+1);
        else run_down(i,i+1);

    //cout<<delta<<" "<<at_least<<" "<<at_most<<endl;

    return at_least<=at_most;
}

int main()
{
    scanf("%i",&hills);
    for(int i=1;i<=hills;i++)scanf("%i",&inp[i]);

    scanf("%i",&f);
    for(int i=1;i<=f;i++)
    {
        int node,h;
        scanf("%i%i",&node,&h);
        forced[node]={h,1};
    }

    long long ok=2e9,not_ok=-1;

    for(int i=1;i<hills;i++)
        not_ok=max(not_ok,inp[i+1]-inp[i]-1LL);

    while(ok-not_ok>1)
    {
        long long av=(ok+not_ok)/2;

        if(valid(av))ok=av;
        else not_ok=av;
    }

    printf("%lld 0\n",ok);

    return 0;
}
/*
7
1 2 4 7 9 11 14
1
6 5

3 29

2
1 10
2
1 -5
5 5

15 5

3
1 2 3
3
1 4
2 100
3 1

96 0
*/
