#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

struct State {
    int minX;
    int maxX;
    int minY;
    int maxY;

    State() {
        this->minX = this->minY = 1e9;
        this->maxX = this->maxY = -1e9;
    }

    int value() {

    }
};

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<pair<int, int>> points;

void read() {
    cin >> n;

    points.resize(n);
    for (auto &i : points) {
        cin >> i.first >> i.second;
    }
}

void solve() {
    int answer = 1e9;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) {
                continue;
            }

            pair<int, int> A = make_pair(points[i].first, points[i].first), B = make_pair(points[j].second, points[j].second);

            for (int k = 0; k < n; k++) {
                if (k == i || k == j) {
                    continue;
                }

                pair<int, int> inA = make_pair(min(A.first, points[k].first), max(A.second, points[k].first));
                pair<int, int> inB = make_pair(min(B.first, points[k].second), max(B.second, points[k].second));

                int currValue = A.second - A.first + B.second - B.first;
                int Avalue = inA.second - inA.first + B.second - B.first;
                int Bvalue = A.second - A.first + inB.second - inB.first;

                if (Avalue - currValue <= Bvalue - currValue) {
                    A = inA;
                } else {
                    B = inB;
                }
            }

            answer = min(answer, A.second - A.first + B.second - B.first);
        }
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
