# include <bits/stdc++.h>
using namespace std;
const int maxn = 2e6+5;
int minl[maxn],maxl[maxn],minr[maxn],maxr[maxn];
int x[maxn],y[maxn];
int MIN(int a, int b)
{
    if(a<b)return a;
    return b;
}
int MAX(int a, int b)
{
    if(a>b)return a;
    return b;
}
int p[maxn];
struct Segment_tree
{
    int segm[3*maxn];
    void init()
    {
        int i;
        for(i = 1; i<3*maxn;i++)
            segm[i] = 1e9;
    }
    void build(int v, int from, int to, int x, int d)
    {

        if(from==to)
        {
            segm[v] = p[from];
            return ;
        }
        int mid = (from+to)/2;
       build(2*v,from,mid,x,d);

            build(2*v+1,mid+1,to,x,d);
        segm[v] = MIN(segm[2*v],segm[2*v+1]);
    }
    void update(int v, int from, int to, int x, int d)
    {
        if(from==to&&from==x)
        {
            segm[v] = d;
            return ;
        }
        int mid = (from+to)/2;
        if(x<=mid)update(2*v,from,mid,x,d);
        else
            update(2*v+1,mid+1,to,x,d);
        segm[v] = MIN(segm[2*v],segm[2*v+1]);
    }
    int query(int v, int from, int to, int x, int y)
    {
        if(x<=from&&to<=y)return segm[v];
        int mid = (from+to)/2;
        int ans = 1e9;
        if(x<=mid)ans = query(2*v,from,mid,x,y);
        if(y>mid)ans = MIN(ans,query(2*v+1,mid+1,to,x,y));
        return ans;
    }
};
Segment_tree allt,downt, upt;int n;
int UPBINARY(int x, int v)
{
    if(maxr[v+1]<=x)return v;
    int uk1 = v;
    int uk2 = n;
    int mid;
    while(uk1<uk2)
    {
        mid = (uk1+uk2)/2;
        if(maxr[mid+1]>x)
            uk1=mid+1;
        else
            uk2 = mid;
    }
    return uk2;
}
int DOWNBINARY(int x, int v)
{
    if(minr[v+1]>=x)return v;int uk1 = v;
    int uk2 = n;
    int mid;
    while(uk1<uk2)
    {
        mid = (uk1+uk2)/2;
        if(minr[mid+1]<x)
            uk1=mid+1;
        else
            uk2 = mid;
    }
    return uk2;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int i,j;
    cin>>n;
    for(i=1;i<=n;i++)
        cin>>x[i]>>y[i];
    minl[0] = 1e9;
    maxl[0] = 0;
    for(i=1;i<=n;i++)
    {
        minl[i] = MIN(minl[i-1],y[i]);
        maxl[i] = MAX(maxl[i-1],y[i]);
    }
    minr[n+1]=  1e9;
    maxr[n+1] = 0;
    for(i=n;i>=1;i--)
    {
        minr[i] = MIN(minr[i+1],y[i]);
        maxr[i] = MAX(maxr[i+1],y[i]);
    }int curr;
    allt.init();
    downt.init();
    upt.init();
    for(i=n;i>=1;i--)
    {
        curr = x[i] + maxr[i+1] - minr[i+1];
        p[i] = curr;
    }
        allt.build(1,1,n,i,curr);  //cout<<"OK"<<endl;
        for(i=n;i>=1;i--){
        curr = x[i] + maxr[i+1];
        p[i]  =curr;
        }
        upt.build(1,1,n,i,curr);
        for(i=n;i>=1;i--)
        {
            curr = x[i] - minr[i+1];
            p[i]  =curr;
        }

        downt.build(1,1,n,i,curr);

    int ans = x[n]-x[1];

    for(i=1;i<=n;i++)
    {
       int TOP = maxl[i-1];
       int DOWN = minl[i-1];
       int idup = UPBINARY(TOP,i);
       int iddown = DOWNBINARY(DOWN,i);
       int j = MAX(idup,iddown);
       if(i>1||j<n)
       {
           curr = x[j] - x[i] + MAX(maxl[i-1],maxr[j+1]) - MIN(minl[i-1],minr[j+1]);
           ans = MIN(ans,curr);
       }
       if(idup>iddown)
       {
           j = upt.query(1,1,n,iddown,idup-1);
           curr = j - x[i] - DOWN;
           ans = MIN(ans,curr);
       }
       if(idup<iddown)
       {
            j = downt.query(1,1,n,idup,iddown-1);
           curr = j - x[i] + TOP;
           ans = MIN(ans,curr);
       }
       j = MIN(idup,iddown) - 1;
       if(j>=i)
       {
           j = allt.query(1,1,n,i,j);
           curr = j - x[i];
           ans = MIN(curr,ans);
       }
    }
    cout<<ans<<'\n';
    return 0;
}
