
#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) v.begin(),v.end()
#define sz(v) ((int)v.size())

using namespace std;

const int N = 1e6;
int n;
pair<int, int> x[N];
pair<int, int> st[4*N]; //mn, mx
int sum;

void input() {
    cin>>n;
    for (int i=0; i<n; i++) {
        cin>>x[i].f>>x[i].s;
    }
}

void output() {
    cout<<sum<<endl;
}

map<int, int> mp;
pair<int, int> p[N];
void compress() {
    set<int> s;
    for (int i=0; i<n; i++) {
        s.insert(x[i].f);
    }

    int curr = 0;
    for (auto id : s) {
        mp[id] = curr++;
    }
}

void calcMinMax() {
    for (int i=0; i<n; i++) {
        p[i].f = 1e9;
        p[i].s = -1e9;
    }
    for (int i=0; i<n; i++) {
        int id = mp[x[i].f];
        p[id].f = min(p[id].f, x[i].s);
        p[id].s = max(p[id].s, x[i].s);
    }
}

pair<int, int> func(const pair<int, int>& a, const pair<int, int>& b) {
    pair<int, int> ans;
    ans.f = min(a.f, b.f);
    ans.s = max(a.s, b.s);
}

void buildSt(int curr, int l, int r) {
    if (l == r) {
        st[curr].f = p[l].f;
        st[curr].s = p[l].s;
        return;
    }

    int mid = (l+r)/2;
    buildSt(curr*2, l, mid);
    buildSt(curr*2+1, mid+1, r);
    st[curr] = func(st[curr*2], st[curr*2+1]);
}

pair<int, int> query(int curr, int l, int r, int rl, int rr) {
    if (l > rr || r < rl) {
        return {1e9, -1e9};
    }

    if (l >= rl && r <= rr) {
        return st[curr];
    }

    int mid = (l+r)/2;
    return func(query(curr*2, l, mid, rl, rr), query(curr*2+1, mid+1, r, rl, rr));
}

void solve() {
    sort(x, x+n);
    /*compress();
    calcMinMax();
    buildSt(1, 0, sz(mp));*/

    sum = 2e9;
    /*for (int i=0; i<n; i++) {
        for (int j=i+1; j<n; j++) {
            pair<int, int> ans = {1e9, -1e9};
            int id = mp[x[i].f];
            if (id > 0) {
                ans = query(1, 0, sz(mp)-1, 0, id-1);
            }
            if (id < sz(mp)-1) {
                ans = func(ans, query(1, 0, sz(mp)-1, id+1, sz(mp)));
            }
            sum = min(sum, ans.s - ans.f + x[j].f - x[i].f);
        }
    }*/

    for (int i=0; i<n; i++) {
        for (int j=i; j<n; j++) {
            pair<int, int> ans = {1e9, -1e9};
            for (int z=0; z<i; z++) {
                ans.f = min(ans.f, x[z].s);
                ans.s = max(ans.s, x[z].s);
            }
            for (int z=j+1; z<n; z++) {
                ans.f = min(ans.f, x[z].s);
                ans.s = max(ans.s, x[z].s);
            }
            if (ans.f == 1e9) {
                ans = {0, 0};
            }
            sum = min(sum, ans.s - ans.f + x[j].f - x[i].f);
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
11
1 28
5 24
11 14
13 43
19 29
23 6
28 25
36 51
39 32
44 29
50 21
*/
