#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
template<typename T> void check_max(T &a, const T &b){ a = (a > b) ? a : b;}
template<typename T> void check_min(T &a, const T &b){ a = (a < b) ? a : b;}
const int N = 2e6 + 3;
const int INF = 5e8;

int n;
pair<int, int> p[N];
int mx_pr[N], mn_pr[N], mx_su[N], mn_su[N], t[N], f_big[N], f_small[N];
int ans = INF;

void init_pr_su(){
    mx_pr[0] = -INF;
    mn_pr[0] = INF;
    for(int i = 1; i <= n; ++i){
        mx_pr[i] = max(mx_pr[i - 1], p[i].second);
        mn_pr[i] = min(mn_pr[i - 1], p[i].second);
    }

    mx_su[n + 1] = -INF;
    mn_su[n + 1] = INF;
    for(int i = n; i >= 1; --i){
        mx_su[i] = max(mx_su[i + 1], p[i].second);
        mn_su[i] = min(mn_su[i + 1], p[i].second);
    }

    int i = 1, j = n;
    while(i != n + 1 && j != 0){
        if(mx_pr[i] >= mx_su[j]){
            --j;
        }
        else{
            f_big[i] = j;
            ++i;
        }
    }
    while(i != n + 1){
        f_big[i] = 0;
        ++i;
    }

    i = 1, j = n;
    while(i != n + 1 && j != 0){
        if(mn_pr[i] <= mn_su[j]){
            --j;
        }
        else{
            f_small[i] = j;
            ++i;
        }
    }
    while(i != n + 1){
        f_small[i] = 0;
        ++i;
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 1; i <= n; ++i)
        cin >> p[i].first >> p[i].second;

    init_pr_su();

    for(int i = 1; i <= n; ++i)
        for(int j = i; j <= n; ++j){
            if(i == 1 && j == n) continue;
            int mx = max(mx_pr[i - 1], mx_su[j + 1]);
            int mn = min(mn_pr[i - 1], mn_su[j + 1]);
            check_min(ans, mx - mn + p[j].first - p[i].first);
        }
    cout << ans << "\n";
}
/*
3
1 17
50 4
100 5
*/
