#include <iostream>
#include <utility>
#include <set>
#define fi first
#define se second
using namespace std;

const int MAXN = 2000006;

int n;
pair<int, int> a[MAXN];
multiset<int> ys, yscp;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i].fi >> a[i].se;
        yscp.insert(a[i].se);
    }
}

int main()
{
    Init();

    int ans = 1 << 30;
    for (int i = 1; i <= n; ++ i)
    {
        ys = yscp;
        for (int j = i; j <= n; ++ j)
        {
            if (i == 1 and j == n) continue;
            ys.erase(ys.find(a[j].se));

            int res = a[j].fi - a[i].fi + *(--ys.end()) - *(ys.begin());
            ans = min(ans, res);
        }
    }

    cout << ans << endl;
    return 0;
}
