#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
const int maxn=1e6+5;
const int inf=1e9+7;
int n,maxx;
int x[2*maxn],y[2*maxn];
int it[8*maxn];
int tree[8*maxn];
///----------------------------------------------
void print_tree(int k, int l, int r)
{
    if(l>r)return;
    if(l==r)
    {
        cout<<k<<"-> "<<tree[k]<< endl;
        return;
    }
    cout<<k<<"-> "<<tree[k]<< endl;
    int mid=(l+r)/2;
    print_tree(k*2,l,mid);
    print_tree(k*2+1,mid+1,r);
}
///----------------------------------------------
void insert_el(int k,int l,int r, int pos, int val)
{
    if(l>r)return;
    if(l==r && l==pos)
    {
        it[k]=val;
        //cout<<k<<"inserted-> "<<val<<endl;
        return;
    }
    if(pos<l || r<pos)return;
    int mid=(l+r)/2;
    insert_el(k*2,l,min(mid,r),pos,val);
    insert_el(k*2+1,max(mid+1,l),r,pos,val);
    if(l!=r){it[k]=max(it[k*2],it[k*2+1]);}
}
///----------------------------------------------
void insert_tree(int k, int l, int r, int pos, int val)
{
    if(l>r)return;
    if(l==r && l==pos)
    {
        tree[k]=val;
        return;
    }
    if(pos<l || r<pos)return;
    int mid=(l+r)/2;
    insert_tree(k*2,l,min(mid,r),pos,val);
    insert_tree(k*2+1,max(mid+1,l),r,pos,val);
    if(l!=r){tree[k]=min(tree[k*2],tree[k*2+1]);}
}
///----------------------------------------------
int find_max(int k,int l,int r, int xax, int yay)
{
   // cout<<l<<" "<<r<<" "<<x<<" "<<y<<endl;
    if(l>r)return 0;
    if(xax<=l && r<=yay){return it[k];}
    if(yay<l || xax>r)return 0;
    int mid=(l+r)/2;
    //cout<<l<<" "<<r<<" miid "<<mid<<endl;
    return max(find_max(k*2,l,mid,xax,yay), find_max(k*2+1,mid+1,r,xax,yay));
}
///----------------------------------------------
int find_min(int k, int l, int r, int xax, int yay)
{
    if(l>r)return inf;
    if(xax<=l && r<=yay){return tree[k];}
    if(yay<l || xax>r)return inf;
    int mid=(l+r)/2;
    //cout<<l<<" "<<r<<" miid "<<mid<<endl;
    return min(find_min(k*2,l,mid,xax,yay), find_min(k*2+1,mid+1,r,xax,yay));
}
///----------------------------------------------
void read()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>x[i]>>y[i];
    }
}
///----------------------------------------------
void solve()
{
    long long int ans=-1;
    //cout<<maxx<<endl;
    //for(int i=0;i<=8*n;i++)tree[i]=inf;

    for(int i=1;i<=n;i++)
    {
        insert_el(1,1,n,i,y[i]);
        insert_tree(1,1,n,i,y[i]);
    }
    //print_tree(1,1,n);
    //cout<<find_max(1,0,n,1,n)<<endl;
    for(int i=1;i<=n;i++)
    {
        for(int j=i;j<=n;j++)
        {
            int mn=inf,mx=0;
            long long int a=x[j]-x[i];
            if(1<=i-1)
                {
                    mx=max(mx,find_max(1,1,n,1,i-1));
                    mn=min(mn,find_min(1,1,n,1,i-1));
                }
            if(j+1<=n){mx=max(mx,find_max(1,1,n,j+1,n));mn=min(mn,find_min(1,1,n,j+1,n));}
            //cout<<mn<<" "<<mx<< endl;
            if(mn==inf && mx==0)continue;
            if(ans>a+(mx-mn) || ans==-1)
            {
                ans=a+(mx-mn);
            }
        }
    }
    cout<<ans<< endl;
}
///----------------------------------------------
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
