#include<bits/stdc++.h>
#pragma optimize GCC ofast
using ll = long long;
using namespace std;

const ll MAXN = 2000002;
const ll DUMMYCODE = 100000004LL;


pair<ll,ll> mergePairs(pair<ll,ll> a, pair<ll,ll> b) {
    if(a.first == DUMMYCODE)
        return b;
    if(b.first == DUMMYCODE)
        return a;
    return {min(a.first, b.first),max(a.second, b.second)};
}

vector<pair<ll,ll>> input;
int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int n;
    cin>>n;
    ll u,v;
    vector<pair<ll,ll>> prefixResults;
    prefixResults.push_back({DUMMYCODE, -1});
    for(int i = 0; i < n; i++) {
        cin>>u>>v;
        input.emplace_back(u + 1,v + 1);
        prefixResults.emplace_back(min(v+1, prefixResults[prefixResults.size()-1].first),
                                   max(v+1, prefixResults[prefixResults.size()-1].second));

    }
    vector<pair<ll,ll>> suffixResults;
    suffixResults.push_back({DUMMYCODE, -1});

    for(int i = n-1; i>=0; i--) {
        suffixResults.emplace_back(min(input[i].second, suffixResults[suffixResults.size()-1].first),
                                   max(input[i].second, suffixResults[suffixResults.size()-1].second));
    }

    vector<int> interesting;
    interesting.push_back(0);
    for(int i = 1; i < n - 1; i++) {
        if(input[i].first != input[i-1].first or input[i].first != input[i+1].first) {
            interesting.push_back(i);
        }
    }
    interesting.push_back(n-1);
    long long res = DUMMYCODE;
    for(int p1 = 0; p1 < interesting.size(); p1++) {
        for(int p2 = p1; p2 < interesting.size(); p2++) {
            if(p1 == 0 and p2 == interesting.size()-1) continue;
            ll dx = input[interesting[p2]].first - input[interesting[p1]].first;
            if(dx > res) {
                break;
            }
            auto yres = mergePairs(prefixResults[interesting[p1]],
                                   suffixResults[n - interesting[p2] - 1]);

            //cout<<interesting[p1]<<","<<interesting[p2]<<":"<<yres.first<<" "<<yres.second<<endl;
            ll dy = yres.second - yres.first;
            if(dx + dy < res) {
                res = dx + dy;
            }
        }
    }
    cout<<res<<endl;
}

