#include <iostream>
#include <cstring>

using namespace std;

const int MAXN = 505;
const int offset = 100;
const int inf = 1e9 + 5;

int n;
int h[MAXN];
bool isSpecial[MAXN];

bool used[2*offset];

int a[MAXN];
bool checkSpecial(int ind)
{
    if(ind==0) return a[0]<a[1];
    if(ind==n-1) return true;

    return ((a[ind-1]<a[ind] && a[ind]>a[ind+1]) || (a[ind-1]>a[ind] && a[ind]<a[ind+1]));
}

int minDiff = offset*5;
int minSum = offset*69;

int memo[MAXN][2*offset+5][2];
int rec(int ind, int last, bool sign, int minVal, int maxVal)
{
    if(ind==n)
    {
        return 0;
    }
    if(memo[ind][last+offset][sign]!=-1)
        return memo[ind][last+offset][sign];

    int minSum = inf;
    for(int x = minVal;x<=maxVal;x++)
    {
        if(h[ind]!=-1 && h[ind]!=x) continue;
        if(sign==false && x>=last) continue;
        if(sign==true && x<=last) continue;

        minSum = min(minSum, isSpecial[ind]*x + rec(ind+1, x, sign^isSpecial[ind], minVal, maxVal));
    }

    memo[ind][last+offset][sign] = minSum;
    return minSum;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int T;
    cin >> T;

    while(T--)
    {
        int x;
        cin >> x;

        n = x;
        isSpecial[x-1] = true;
    }

    for(int i = 0;i<=n;i++) h[i] = -1;

    cin >> T;
    while(T--)
    {
        int ind, curr;
        cin >> ind >> curr;ind--;

        h[ind] = curr;
    }

    for(int diff = 0;diff<=offset;diff++)
    {
        for(int minVal = -offset;minVal<=offset-diff;minVal++)
        {
            int maxVal = minVal + diff;
            memset(memo, -1, sizeof(memo));

            int sum = inf;
            for(int x = minVal;x<=maxVal;x++)
            {
                if(h[0]!=-1 && h[0]!=x) continue;
                sum = min(sum, x + rec(1, x, true, minVal, maxVal));
            }

            if(sum<inf/2)
            {
                cout << diff << " " << sum << '\n';
                return 0;
            }
        }
    }

//    rec(0);
//    cout << minDiff << " " << minSum << '\n';
}
