#include <iostream>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 2000005
const int one = 1;
const int INF = (one << 62);
int br;
pair<int, int> point[MAXN];
int minpr[MAXN], maxpr[MAXN], minsuf[MAXN], maxsuf[MAXN];
int minprf(int i)
{
    if(i < 0) return INF;
    else return minpr[i];
}
int maxprf(int i)
{
    if(i < 0) return 0;
    else return maxpr[i];
}
int minsuff(int i)
{
    if(i >= br) return INF;
    else return minsuf[i];
}
int maxsuff(int i)
{
    if(i >= br) return 0;
    else return maxsuf[i];
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> br;
    int miny = INF, maxy = -INF;
    for(int i = 0; i < br; ++i){
        int x, y; cin >> x >> y;
        point[i] = {x, y};
        miny = min(miny, y);
        maxy = max(maxy, y);
    }
    minpr[0] = point[0].second; maxpr[0] = point[0].second;
    for(int i = 1; i < br; ++i){
        minpr[i] = min(minpr[i - 1], point[i].second);
        maxpr[i] = max(maxpr[i - 1], point[i].second);
    }
    minsuf[br - 1] = point[br - 1].second; maxsuf[br - 1] = point[br - 1].second;
    for(int i = br - 2; i >= 0; --i){
        minsuf[i] = min(minsuf[i + 1], point[i].second);
        maxsuf[i] = max(maxsuf[i + 1], point[i].second);
    }
    int minimum = INF;
    for(int i = 0; i < br; ++i){
        for(int z = i + 1; z < br; ++z){
            if(i == 0 && z == br - 1){
                minimum = min(minimum, point[z].first - point[i].first); continue;
            }
            int calc = point[z].first - point[i].first;
            int mini = min(minprf(i - 1), minsuff(z + 1));
            int maxi = max(maxprf(i - 1), maxsuff(z + 1));
            //cout << i << ' ' << z << ' ' << calc << ' ' << maxi << ' ' << mini << endl;
            calc += (maxi - mini);
            minimum = min(minimum, calc);
        }
    }
    minimum = min(minimum, maxy - miny);
    cout << minimum << endl;
    return 0;
}
