#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
#define endl "\n"
typedef long long ll;
const ll mod = 1e15 + 7;
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}

const ll MAX_N = 2e6 + 10;
pair<ll, ll> p[MAX_N];
ll n;
ll mxsuf[MAX_N], mnsuf[MAX_N], mnpref[MAX_N], mxpref[MAX_N];

ll cost(ll i, ll j) {
    if(j - i + 1 == n) {return mod;}
    return p[i].first - p[j].first + max(mxsuf[i], mxpref[j]) - min(mnsuf[i], mnpref[j]);
}

ll f(ll x) {
    ll indr = 0, ret = mod;
    for(int indl = 0; indl < n; indl ++) {
        while(indr + 1 < n && p[indr + 1].first - p[indl].first <= x) {
            indr ++;
        }
        if(indl == 0 && indr == n - 1) {indr = n - 2;}
        chkmin(ret, cost(indr, indl));
    }
    return ret;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n;
    srand(time(NULL));
    for(ll i = 0; i < n; i ++) {
        cin >> p[i].first >> p[i].second;
    }
    for(ll i = 0; i < n; i ++) {
        if(i == 0) {
            mnpref[i] = mod;
            mxpref[i] = -mod;
        } else {
            mnpref[i] = min(mnpref[i - 1], p[i - 1].second);
            mxpref[i] = max(mxpref[i - 1], p[i - 1].second);
        }
    }
    for(ll i = n - 1; i >= 0; i --) {
        if(i == n - 1) {
            mnsuf[i] = mod;
            mxsuf[i] = -mod;
        } else {
            mnsuf[i] = min(mnsuf[i + 1], p[i + 1].second);
            mxsuf[i] = max(mxsuf[i + 1], p[i + 1].second);
        }
    }
    cout << endl;
    ll l = 0, r = p[n - 1].first - p[0].first;
    ll ret = mod;
    while(l < r - 5) {
        ll m1 = l + (r - l) / 3, m2 = l + (r - l) * 2 / 3;
        ll f1 = f(m1), f2 = f(m2);
        chkmin(ret, f1);
        chkmin(ret, f2);
        if(f1 >= f2) {
            l = m1;
        } else {
            r = m2;
        }
    }
    for(int i = l; i <= r; i ++) {
        chkmin(ret, f(i));
    }
    cout << ret << endl;
    return 0;
}

/*
11
1 28
5 24
11 14
13 43
19 29
23 6
28 25
36 51
39 32
44 29
50 21
*/
