#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 1048576;
const long long INF = 9876543219876;

struct pnt
{
    int x; // x
    long long h; // height
    int t; // type: -1 - dol, 0 - neutral, 1 - vryh
    int isc; // if it comes from input
};

int n, t, w;
vector<int> hl;
vector<pnt> known; int v; long long vh;

vector<pnt> allp;
int phl, pknown;



long long minV, maxV;

long long sums(long long k)
{
    long long ans = (k*(k+1))/2;
    return ans;
}

long long sumOfNumsBtw(long long a, long long b) // a >= b
{
    if(a > 0 && b > 0){
        return (long long)(sums(a) - sums(b-1));
    }
    if(a < 0 && b < 0){
        return (long long)(-sums(-b) + sums(-a-1));
    }
    if(a > 0 && b <= 0){
        return (long long)(sums(a) - sums(-b));
    }
    if(a == 0){
        return (long long)(-sums(-b));
    }
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //cout << sumOfNumsBtw(5, 3) << " " << sumOfNumsBtw(-3, -9) << " " << sumOfNumsBtw(0, -2) << " " << sumOfNumsBtw(3, -1) << endl;

    cin >> t;
    for(int i = 0; i < t; i++){
        cin >> n;
        hl.push_back(n);
    }
    cin >> w;
    for(int i = 0; i < w; i++){
        cin >> v >> vh;
        known.push_back({v, vh, 0, 1});
    }


    for(int i = 0; i < t+w; i++){
        if(phl < t && pknown < w){
            if(hl[phl] < known[pknown].x){
                int vid;
                if(phl % 2 == 0){
                    vid = -1;
                    allp.push_back({hl[phl], INF, vid, 0});
                }else{
                    vid = 1;
                    allp.push_back({hl[phl], -INF, vid, 0});
                }
                phl++;
            }else if(hl[phl] > known[pknown].x){
                allp.push_back({known[pknown].x, known[pknown].h, 0, 1});
                pknown++;
            }else{
                int vid;
                if(phl % 2 == 0) vid = -1;
                else vid = 1;
                allp.push_back({hl[phl], known[pknown].h, vid, 1});
                phl++; pknown++; i++;
            }
        }else if(phl < t){
            int vid;
            if(phl % 2 == 0){
                vid = -1;
                allp.push_back({hl[phl], INF, vid, 0});
            }else{
                vid = 1;
                allp.push_back({hl[phl], -INF, vid, 0});
            }
            phl++;
        }else{
            allp.push_back({known[pknown].x, known[pknown].h, 0, 1});
            pknown++;
        }
    }

    maxV = -INF;
    minV = INF;

    for(int i = 1; i < allp.size(); i++){
        if(allp[i].isc == 0){
            if(allp[i].t == 1){
                if(allp[i-1].isc == 1){
                    allp[i].h = allp[i-1].h + (allp[i].x - allp[i-1].x);
                    maxV = max(maxV, allp[i].h);
                }
            }
        }else{
            if(allp[i].t == 1){
                maxV = max(maxV, allp[i].h);
                continue;
            }
            if(allp[i-1].t == 1 && allp[i-1].isc == 0){
                allp[i-1].h = max(allp[i-1].h, allp[i].h + (allp[i].x - allp[i-1].x));
                maxV = max(maxV, allp[i-1].h);
            }
        }
    }

    //cout << maxV << endl;

    for(int i = 0; i < allp.size(); i++){
        if(allp[i].t == -1){
            if(i > 0 && allp[i].isc == 0){
                if(allp[i-1].isc == 1){
                    allp[i].h = allp[i-1].h - (allp[i].x - allp[i-1].x);
                    minV = min(minV, allp[i].h);
                }else{
                    allp[i].h = maxV - (allp[i].x - allp[i-1].x);
                    minV = min(minV, allp[i].h);
                }
            }else{
                if(allp[i].isc == 1){
                    minV = min(minV, allp[i].h);
                    continue;
                }
            }
        }else if(allp[i-1].isc == 0){
            if(allp[i].isc == 1){
                allp[i-1].h = min(allp[i-1].h, allp[i].h - (allp[i].x - allp[i-1].x)); //check
                minV = min(minV, allp[i-1].h);
                continue;
            }
            if(allp[i].t == 1){
                allp[i-1].h = min(allp[i-1].h, maxV - (allp[i].x - allp[i-1].x)); //check
                minV = min(minV, allp[i-1].h);
                continue;
            }
        }
    }
    //cout << allp[allp.size()-1].h << endl;

    cout << maxV - minV << endl;

return 0;
}
