#include<iostream>
#include<deque>
using namespace std;

struct point
{
    int x;
    int y;
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    deque<point> a, b;

    for(int i=0; i<n; i++)
    {
        point p;
        cin >> p.x >> p.y;

        a.push_back(p);
    }

    bool updated=true;
    int minSum=a.back().x-a.front().x;

    while(updated)
    {
        if(a.size()==1)
        {
            break;
        }

        if(b.empty())
        {
            point left=a.front(), right=a.back();
            a.pop_front(), a.pop_back();

            if(right.x-a.front().x<a.back().x-left.x)
            {
                b.push_back(left);
                a.push_back(right);
            }
            else
            {
                b.push_back(right);
                a.push_front(left);
            }

            minSum=a.back().x-a.front().x;

            //cout << a.front().x << " " << a.back().x << " " << b.front().y << " " << b.back().y << endl;

            continue;
        }

        if(a.front().y<=b.back().y && a.front().y>=b.front().y)
        {
            point temp=b.back();
            b.pop_back();

            b.push_back(a.front());
            b.push_back(temp);

            a.pop_front();

            minSum=(a.back().x-a.front().x)+(b.back().y-b.front().y);

                //cout << a.front().x << " " << a.back().x << " " << b.front().y << " " << b.back().y << endl;

            continue;
        }

        if(a.back().y<=b.back().y && a.back().y>=b.front().y)
        {
            point temp=b.back();
            b.pop_back();

            b.push_back(a.back());
            b.push_back(temp);

            a.pop_back();

            minSum=(a.back().x-a.front().x)+(b.back().y-b.front().y);

                //cout << a.front().x << " " << a.back().x << " " << b.front().y << " " << b.back().y << endl;

            continue;
        }

        updated=false;

        if(a.front().y<b.front().y)
        {
            point left=a.front();
            a.pop_front();

            if(minSum>=(a.back().x-a.front().x)+(b.back().y-left.y))
            {
                b.push_front(left);

                minSum=(a.back().x-a.front().x)+(b.back().y-b.front().y);

                updated=true;

                    //cout << a.front().x << " " << a.back().x << " " << b.front().y << " " << b.back().y << endl;

                continue;
            }
            else
            {
                a.push_front(left);
            }
        }

        if(a.front().y>b.back().y)
        {
            point left=a.front();
            a.pop_front();

            if(minSum>=(a.back().x-a.front().x)+(left.y-b.front().y))
            {
                b.push_back(left);

                minSum=(a.back().x-a.front().x)+(b.back().y-b.front().y);

                updated=true;

                    //cout << a.front().x << " " << a.back().x << " " << b.front().y << " " << b.back().y << endl;

                continue;
            }
            else
            {
                a.push_front(left);
            }
        }

        if(a.back().y<b.front().y)
        {
            point right=a.back();
            a.pop_back();

            if(minSum>=(a.back().x-a.front().x)+(b.back().y-right.y))
            {
                b.push_front(right);

                minSum=(a.back().x-a.front().x)+(b.back().y-b.front().y);

                updated=true;

                    //cout << a.front().x << " " << a.back().x << " " << b.front().y << " " << b.back().y << endl;

                continue;
            }
            else
            {
                a.push_back(right);
            }
        }

        if(a.back().y>b.back().y)
        {
            point right=a.back();
            a.pop_back();

            if(minSum>=(a.back().x-a.front().x)+(right.y-b.front().y))
            {
                b.push_back(right);

                minSum=(a.back().x-a.front().x)+(b.back().y-b.front().y);

                updated=true;

                    //cout << a.front().x << " " << a.back().x << " " << b.front().y << " " << b.back().y << endl;

                continue;
            }
            else
            {
                a.push_back(right);
            }
        }
    }

    minSum=(a.back().x-a.front().x)+(b.back().y-b.front().y);

    cout << minSum << "\n";

    return 0;
}

/*
5
1 1
1 20
3 3
5 5
23 4
*/
