#pragma GCC optimize("O3")
#pragma GCC optimize("sse4")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long int
#define ld long double
#define bit(idx) idx&(-idx)
#define bin(x) bitset<32>(x).to_string()
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>
#define ordered_set_T ll

using namespace std;
using namespace __gnu_pbds;

typedef tree<ordered_set_T, null_type, less<ordered_set_T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x) -> how many elements are smaller than x



int main(){
    /// ios_base::sync_with_stdio(false); cin.tie(NULL);
    int n; cin >> n;
    vector<pair<ll, ll>> A(n);
    for(int i = 0; i < n; i ++) cin >> A[i].fr >> A[i].sc;
    row prefix_max(n), prefix_min(n), suffix_max(n), suffix_min(n);
    for(int i = 0; i < n; i ++){
        if(i){
            prefix_min[i] = min(A[i].sc, prefix_min[i - 1]);
            prefix_max[i] = max(A[i].sc, prefix_max[i - 1]);
        }
        else
            prefix_min[i] = prefix_max[i] = A[i].sc;
    }
    for(int i = n - 1; i > 0; i --){
        if(i < n - 1){
            suffix_min[i] = min(A[i].sc, suffix_min[i + 1]);
            suffix_max[i] = max(A[i].sc, suffix_max[i + 1]);
        }
        else
            suffix_min[i] = suffix_max[i] = A[i].sc;
    }
    ll ans = LLONG_MAX;
    for(int L = 0; L < n; L ++){
        for(int R = L; R < n; R ++){
            ll a = (L - 1 >= 0 ? prefix_max[L - 1] : 0);
            ll b = (R + 1 <  n ? suffix_max[R + 1] : 0);
            ll c = (L - 1 >= 0 ? prefix_min[L - 1] : 0);
            ll d = (R + 1 <  n ? suffix_min[R + 1] : 0);
            ans = min(ans, (A[R].fr - A[L].fr) + (max(a, b) - min(c, d)));
        }
    }
    cout << ans << endl;
}
/**
11
1 28
5 24
11 14
13 43
19 29
23 6
28 25
36 51
39 32
44 29
50 21
*/
