#include<iostream>
#include<vector>
using namespace std;

const int mnogo = 100000001;

struct DanniZaTochka{
    int x;
    int y;
};

int broiTochki;
DanniZaTochka tochki[2000010];

vector<DanniZaTochka> tochkiNaAlis;
vector<DanniZaTochka> tochkiNaBob;

int sumaPriTolkova(){
    if(tochkiNaAlis.size() == 0 || tochkiNaBob.size() == 0){
        return 2*mnogo;
    }

    int naiMalakPoX = mnogo;
    int naiGolqmPoX = 0;

    int naiMalakPoY = mnogo;
    int naiGolqmPoY = 0;

    for(int i = 0; i < tochkiNaAlis.size(); i++){
        naiMalakPoX = min(naiMalakPoX, tochkiNaAlis[i].x);
        naiGolqmPoX = max(naiGolqmPoX, tochkiNaAlis[i].x);
    }

    for(int i = 0; i < tochkiNaBob.size(); i++){
        naiMalakPoY = min(naiMalakPoY, tochkiNaBob[i].y);
        naiGolqmPoY = max(naiGolqmPoY, tochkiNaBob[i].y);
    }

    //cout<<naiMalakPoX<<" "<<naiGolqmPoX<<"  "<<naiMalakPoY<<" "<<naiGolqmPoY<<endl;

    int zaVrasht = (naiGolqmPoX - naiMalakPoX) + (naiGolqmPoY - naiMalakPoY);

    return zaVrasht;
}

int otgovor = 2*mnogo;

void nameriOtgovora(int naKoqTochkaSme){
    if(naKoqTochkaSme == broiTochki){
        otgovor = min(otgovor, sumaPriTolkova());

        return ;
    }

    tochkiNaAlis.push_back(tochki[naKoqTochkaSme]);
    nameriOtgovora(naKoqTochkaSme + 1);
    tochkiNaAlis.pop_back();

    tochkiNaBob.push_back(tochki[naKoqTochkaSme]);
    nameriOtgovora(naKoqTochkaSme + 1);
    tochkiNaBob.pop_back();
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>broiTochki;

    for(int i = 0; i < broiTochki; i++){
        cin>>tochki[i].x>>tochki[i].y;
    }

    nameriOtgovora(0);

    cout<<otgovor<<endl;

    return 0;
}
