#include <iostream>
#include <stdio.h>
using namespace std;

int t, n, w;
int peaks[1000111];
pair<int, int> info[1000111];
bool known[1000111];
int h[1000111];
int bound[1000111];

int main()
{
    int i, j;

    scanf("%d", &t);

    int maxStreak = 0;
    for (i=1;i<=t;i++)
    {
        scanf("%d", &peaks[i]);

        if (i > 1)
            maxStreak = max(maxStreak, peaks[i] - peaks[i-1]);
    }
    n = peaks[t];

    scanf("%d", &w);

    for (i=1;i<=w;i++)
    {
        scanf("%d %d", &info[i].first, &info[i].second);
        known[ info[i].first ] = true;
        h[ info[i].first ] = info[i].second;
    }

    int maxLower = 1000001, minUpper = -1000001;
    for (i=1;i<=t;i++)
    {
        if (i % 2 == 1)
            bound[i] = 1000001;
        else
            bound[i] = -1000001;

        if (i != 1)
        {
            for (j=peaks[i];j>=peaks[i-1];j--)
            {
                if (known[j])
                {
                    if (i % 2 == 1)
                    {
                        bound[i] = h[j] - (peaks[i] - j);
                        maxLower = min(maxLower, h[j] - (peaks[i] - j));
                    }
                    else
                    {
                        bound[i] = h[j] + (peaks[i] - j);
                        minUpper = max(minUpper, h[j] + (peaks[i] - j));
                    }

                    break;
                }
            }
        }

        if (i != t)
        {
            for (j=peaks[i];j<=peaks[i+1];j++)
            {
                if (known[j])
                {
                    if (i % 2 == 1)
                    {
                        bound[i] = min(bound[i], h[j] - (j - peaks[i]));
                        maxLower = min(maxLower, h[j] - (j - peaks[i]));
                    }
                    else
                    {
                        bound[i] = max(bound[i], h[j] + (j - peaks[i]));
                        minUpper = max(minUpper, h[j] + (j - peaks[i]));
                    }

                    break;
                }
            }
        }
    }

    if (maxLower >= minUpper)
    {
        maxLower = 0;
        minUpper = maxStreak;
    }
    else if (minUpper - maxLower < maxStreak)
    {
        maxLower = minUpper - maxStreak;
    }

    for (i=1;i<=t;i++)
    {
        if (!known[ peaks[i] ])
        {
            if (i % 2 == 1)
                h[ peaks[i] ] = maxLower;
            else
                h[ peaks[i] ] = minUpper;
        }
    }

    ///Push upper peaks
    for (i=2;i<=t;i+=2)
    {
        if (known[ peaks[i] ])
            continue;

        int minGo = bound[i];
        minGo = max(minGo, h[ peaks[i-1] ] + (peaks[i] - peaks[i-1]));
        if (i != t)
            minGo = max(minGo, h[ peaks[i+1] ] + (peaks[i+1] - peaks[i]));

        h[ peaks[i] ] = minGo;
    }

    int cost = 0;
    for (i=1;i<=t;i++)
    {
        cost += h[ peaks[i] ];
    }

    printf("%d %d\n", minUpper - maxLower, cost);

    return 0;
}
