#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;

const int maxn = 2000006, inf = 1e9;
int n;
pair <int, int> points [maxn];
int maxr [maxn], minr [maxn];
int val1 [maxn], val2 [maxn], val3 [maxn], val4 [maxn];

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 1; i <= n; i ++) cin >> points [i].x >> points [i].y;
    minr [n + 1] = inf;
    val1 [n + 1] = points [n].x;
    for (int i = n; i > 0; i --){
        maxr [i] = max (maxr [i + 1], points [i].y);
        minr [i] = min (minr [i + 1], points [i].y);
        val1 [i] = points [i - 1].x;
        val2 [i] = maxr [i] + points [i - 1].x;
        val3 [i] = - minr [i] + points [i - 1].x;
        val4 [i] = maxr [i] - minr [i] + points [i - 1].x;
    }
    int ans = 1e9;
    int maxl = 0, minl = inf;
    for (int i = 1; i <= n; i ++){
        int l = i, r = n;
        while (l < r){
            int mid = (l + r + 1) >> 1;
            if (maxr [mid] > maxl && minr [mid] < minl) l = mid;
            else r = mid - 1;
        }
        int pos1 = l;
        l = pos1, r = n;
        while (l < r){
            int mid = (l + r + 1) >> 1;
            if (maxr [mid] > maxl || minr [mid] < minl) l = mid;
            else r = mid - 1;
        }
        int pos2 = l;
        int min1 = inf, min2 = inf, min3 = inf;
        for (int j = i + 1; j <= pos1; j ++) min1 = min (min1, val4 [j]);
        if (maxr [pos2] > maxl) for (int j = pos1 + 1; j <= pos2; j ++) min2 = min (min2, val2 [j]);
        else for (int j = pos1 + 1; j <= pos2; j ++) min2 = min (min2, val3 [j]);
        min3 = val1 [pos2 + 1];
        if (pos1 > i) ans = min (ans, min1 - points [i].x);
        if (pos2 != pos1){
            if (maxr [pos2] > maxl) ans = min (ans, min2 - minl - points [i].x);
            else ans = min (ans, min2 + maxl - points [i].x);
        }
        ans = min (ans, max (0, maxl - minl) + min3 - points [i].x);
        maxl = max (maxl, points [i].y);
        minl = min (minl, points [i].y);
        /*for (int j = i; j < n; j ++){
            int y = max ((i == 0 ? 0 : maxl [i - 1]), maxr [j + 1]) - min ((i == 0 ? 100000000 : minl [i - 1]), minr [j + 1]);
            if (y < 0) y = 0;
            int x = points [j].x - points [i].x;
            ans = min (ans, x + y);
        }*/
    }
    cout << ans << '\n';

}
