#include <bits/stdc++.h>
using namespace std;

const int maxn = 300005, inf = 2e9;
int n, t, w;
vector <int> peaks;
int minh [maxn], maxh [maxn], dir [maxn];
bool pk [maxn];
vector <pair <int, int> > known;
int min_maxh = inf, max_minh = -inf;

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> t;
    peaks.resize (t);
    for (int i = 0; i < t; i ++) cin >> peaks [i], pk [peaks [i]] = 1;
    n = peaks.back ();
    for (int i = 1; i < t; i ++){
        for (int j = peaks [i - 1]; j < peaks [i]; j ++){
            dir [j] = i % 2;
        }
    }
    for (int i = 1; i <= n; i ++){
        minh [i] = maxh [i] = -inf;
    }
    cin >> w;
    for (int i = 0; i < w; i ++){
        int k, h;
        cin >> k >> h;
        known.push_back ({k, h});
    }
    for (int W = 0; W < w; W ++){
        int k = known [W].first, h = known [W].second;
        minh [k] = maxh [k] = h;
        if (pk [k]){
            if (dir [k]){
                min_maxh = min (min_maxh, maxh [k]);
            }
            else{
                max_minh = max (max_minh, minh [k]);
            }
        }
        for (int i = k - 1; i > (W == 0 ? 0 : known [W - 1].first); i --){
            if (dir [i]){
                maxh [i] = maxh [i + 1] - 1;
                if (pk [i]){
                    min_maxh = min (min_maxh, maxh [i]);
                    break;
                }
            }
            else{
                minh [i] = minh [i + 1] + 1;
                if (pk [i]){
                    max_minh = max (max_minh, minh [i]);
                    break;
                }
            }
        }
        for (int i = k + 1; i < (W == w - 1 ? n + 1 : known [W + 1].first); i ++){
            if (dir [i - 1]){
                minh [i] = minh [i - 1] + 1;
                if (pk [i]){
                    max_minh = max (max_minh, minh [i]);
                    break;
                }
            }
            else{
                maxh [i] = maxh [i - 1] - 1;
                if (pk [i]){
                    min_maxh = min (min_maxh, maxh [i]);
                    break;
                }
            }
        }
    }
    int ans = max_minh - min_maxh;
    for (int i = 1; i < t; i ++){
        ans = max (ans, peaks [i] - peaks [i - 1]);
    }
    cout << ans << ' ';
    min_maxh = max_minh - ans;
    ans = 0;
    for (int i = 0; i < t; i ++){
        if (i % 2 == 0) ans += min_maxh;
        else{
            int h = minh [peaks [i]];
            h = max (h, min_maxh + peaks [i] - peaks [i - 1]);
            if (i != t - 1) h = max (h, min_maxh + peaks [i + 1] - peaks [i]);
            ans += h;
        }
    }
    cout << ans << '\n';

}
