#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;
/// postavi granici i q zarqza
/// takava hubava jena razplakvash ti
/// den mporo den mporo tinakano
/// moi gelas se koito kaitahano

const int maxn = 6e5 + 3;
const int maxlog = 23;
const int inf = 1e9;

int n;
pair <int, int> a[maxn];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    cin >> a[i].first >> a[i].second;
}

pair <int, int> pref[maxn], suff[maxn];
int calc(int l, int r)
{
    if (l == 1 && r == n)
        return inf;

    return max(pref[l-1].second, suff[r+1].second) - min(pref[l-1].first, suff[r+1].first) + a[r].first - a[l].first;
}

int t1[maxn][maxlog], t2[maxn][maxlog], t3[maxn][maxlog];
int lg[maxn];

void precompute()
{
    for (int i = 2; i <= n; i++)
        lg[i] = lg[i / 2] + 1;

    for (int i = 1; i <= n; i++)
    {
        t1[i][0] = -a[i].first + pref[i-1].second - pref[i-1].first;
        t2[i][0] = -a[i].first + pref[i-1].second;
        t3[i][0] = -a[i].first - pref[i-1].first;
    }

    for (int j = 1; j < maxlog; j++)
    for (int i = 1; i <= n; i++)
    {
        t1[i][j] = t1[i][j-1];
        t2[i][j] = t2[i][j-1];
        t3[i][j] = t3[i][j-1];

        int nxt = i + (1 << (j-1));
        if (nxt <= n)
        {
            t1[i][j] = min(t1[i][j], t1[nxt][j-1]);
            t2[i][j] = min(t2[i][j], t2[nxt][j-1]);
            t3[i][j] = min(t3[i][j], t3[nxt][j-1]);
        }
    }
}

int get1(int l, int r)
{
    if (l > r)
        return inf;

    int curr_lg = lg[r - l + 1];
    return min(t1[l][curr_lg], t1[r - (1 << curr_lg) + 1][curr_lg]);
}

int get2(int l, int r)
{
    if (l > r)
        return inf;

    int curr_lg = lg[r - l + 1];
    return min(t2[l][curr_lg], t2[r - (1 << curr_lg) + 1][curr_lg]);
}

int get3(int l, int r)
{
    if (l > r)
        return inf;

    int curr_lg = lg[r - l + 1];
    return min(t3[l][curr_lg], t3[r - (1 << curr_lg) + 1][curr_lg]);
}

void solve()
{
    pref[0] = suff[n+1] = {inf, -inf};
    for (int i = 1; i <= n; i++)
    {
        pref[i].first = min(pref[i-1].first, a[i].second);
        pref[i].second = max(pref[i-1].second, a[i].second);
    }

    for (int i = n; i >= 1; i--)
    {
        suff[i].first = min(suff[i+1].first, a[i].second);
        suff[i].second = max(suff[i+1].second, a[i].second);
    }

    precompute();

    int ans = inf;
    for (int i = 1; i <= n-1; i++)
    {
        int mins = suff[i+1].first, maxs = suff[i+1].second;
        int low = 0, high = i-1;
        while (low < high)
        {
            int mid = (low + high + 1) / 2;
            if (pref[mid].first >= mins)
                low = mid;

            else
                high = mid-1;
        }

        int opt_l = low;
        low = 0, high = i-1;
        while (low < high)
        {
            int mid = (low + high + 1) / 2;
            if (pref[mid].second <= maxs)
                low = mid;

            else
            high = mid - 1;
        }

        int opt_r = low;
        if (opt_l <= opt_r)
        {
            ans = min(ans, a[i].first - a[opt_l + 1].first + maxs - mins);
            ans = min(ans, a[i].first + maxs + get3(opt_l + 2, opt_r + 1));
            ans = min(ans, a[i].first + get1(opt_r + 2, i));
        }

        else
        {
            ans = min(ans, a[i].first - a[opt_r + 1].first + maxs - mins);
            ans = min(ans, a[i].first - mins + get2(opt_r + 2, opt_l + 1));
            ans = min(ans, a[i].first + get1(opt_l + 2, i));
        }
    }

    for (int i = n; i >= 1; i--)
        ans = min(ans, calc(i, n));

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
