#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;
/// postavi granici i q zarqza
/// takava hubava jena razplakvash ti
/// den mporo den mporo tinakano
/// moi gelas se koito kaitahano

const int maxn = 2e6 + 10;
const int inf = 1e9;

int n;
pair <int, int> a[maxn];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    cin >> a[i].first >> a[i].second;
}

pair <int, int> pref[maxn], suff[maxn];
int calc(int l, int r)
{
    if (l == 1 && r == n)
        return inf;

    return max(pref[l-1].second, suff[r+1].second) - min(pref[l-1].first, suff[r+1].first) + a[r].first - a[l].first;
}

int tr[maxn * 4][3];
void build(int v, int l, int r)
{
    if (l == r)
    {
        tr[v][0] = -a[l].first - pref[l-1].first + pref[l-1].second;
        tr[v][1] = -a[l].first + pref[l-1].second;
        tr[v][2] = -a[l].first - pref[l-1].first;

        return;
    }

    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);

    for (int j = 0; j < 3; j++)
    tr[v][j] = min(tr[v * 2][j], tr[v * 2 + 1][j]);
}

int get(int v, int l, int r, int ll, int rr, int idx)
{
    if (ll > rr)
    return inf;

    if (l > rr || r < ll)
        return inf;

    if (l >= ll && r <= rr)
        return tr[v][idx];

    int mid = (l + r) / 2;
    return min(get(v * 2, l, mid, ll, rr, idx), get(v * 2 + 1, mid + 1, r, ll, rr, idx));
}

void solve()
{
    pref[0] = suff[n+1] = {inf, -inf};
    for (int i = 1; i <= n; i++)
    {
        pref[i].first = min(pref[i-1].first, a[i].second);
        pref[i].second = max(pref[i-1].second, a[i].second);
    }

    for (int i = n; i >= 1; i--)
    {
        suff[i].first = min(suff[i+1].first, a[i].second);
        suff[i].second = max(suff[i+1].second, a[i].second);
    }

    build(1, 1, n);

    int ans = inf;
    int opt_l = 0, opt_r = 0;
    for (int i = n-1; i >= 1; i--)
    {
        int mins = suff[i+1].first, maxs = suff[i+1].second;
        while (opt_l <= i-2 && pref[opt_l+1].first >= mins)
            opt_l++;

        while (opt_r <= i-2 && pref[opt_r+1].second <= maxs)
            opt_r++;

        opt_l = min(opt_l, i-1);
        opt_r = min(opt_r, i-1);

        if (opt_l <= opt_r)
        {
            ans = min(ans, a[i].first - a[opt_l + 1].first + maxs - mins);
            ans = min(ans, a[i].first + maxs + get(1, 1, n, opt_l + 2, opt_r + 1, 2));
            ans = min(ans, a[i].first + get(1, 1, n, opt_r + 2, i, 0));
        }

        else
        {
            ans = min(ans, a[i].first - a[opt_r + 1].first + maxs - mins);
            ans = min(ans, a[i].first - mins + get(1, 1, n, opt_r + 2, opt_l + 1, 1));
            ans = min(ans, a[i].first + get(1, 1, n, opt_l + 2, i, 0));
        }
    }

    for (int i = n; i >= 1; i--)
        ans = min(ans, calc(i, n));

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
