#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;
/// postavi granici i q zarqza
/// takava hubava jena razplakvash ti
/// den mporo den mporo tinakano
/// moi gelas se koito kaitahano

const int maxn = 503;
const int inf = 1e9 + 3;

int n, t;
int a[maxn];
int val[maxn];

void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];

    for (int i = 1; i <= a[n]; i++)
        val[i] = inf;

    cin >> t;
    for (int i = 1; i <= t; i++)
    {
        int pos;
        cin >> pos;
        cin >> val[pos];
    }
}

bool is[maxn];
vector <int> adj[maxn];

int dist[maxn][maxn];
void bfs(int ver)
{
    for (int i = 1; i <= a[n]; i++)
        dist[ver][i] = -1;

    dist[ver][ver] = 0;
    queue <int> q;
    q.push(ver);

    while (!q.empty())
    {
        int curr = q.front();
        q.pop();

        for (auto i: adj[curr])
        if (dist[ver][i] == -1)
        {
            dist[ver][i] = dist[ver][curr] + 1;
            q.push(i);
        }
    }
}

int max_in[maxn], max_out[maxn];
void solve()
{
    for (int i = 2; i <= n; i++)
    for (int j = a[i]; j > a[i-1]; j--)
    is[j] = (i & 1);

    for (int i = 2; i <= a[n]; i++)
    {
        if (!is[i])
        adj[i-1].push_back(i);

        else
        adj[i].push_back(i-1);
    }

    for (int i = 1; i <= a[n]; i++)
        bfs(i);

    for (int i = 1; i <= a[n]; i++)
        for (int j = 1; j <= a[n]; j++)
    {
        max_in[i] = max(max_in[i], dist[j][i]);
        max_out[i] = max(max_out[i], dist[i][j]);
    }

    int ans = 0;
    for (int i = 1; i <= a[n]; i++)
        for (int j = 1; j <= a[n]; j++)
        if (val[i] != inf && val[j] != inf)
        if (dist[i][j] != -1)
        ans = max(ans, max_in[i] + max_out[j] + val[j] - val[i]);

    for (int i = 1; i <= a[n]; i++)
        for (int j = 1; j <= a[n]; j++)
        ans = max(ans, dist[i][j]);

    cout << ans << " " << 0 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
