#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;
struct pt{
    int x,y;
    bool operator <(pt a)const{
        return this->x<a.x;
    }
};
vector<pt>pts;
int rmq[3000000][32];
int lmin[3000000],lmax[3000000];
int rmin[3000000],rmax[3000000];
int vals[3000000];
int logs[3000000];
int query(int a,int b){
    if(a==b){
        return rmq[a][0];
    }
    int log=logs[b-a+1];
    //cout<<"in: "<<a<<" "<<b<<" "<<log<<endl;
    if(vals[rmq[a][log]]<vals[rmq[b-(1<<log)+1][log]]){
        return rmq[a][log];
    }else{
        //cout<<b-(1<<log)+1;
        return rmq[b-(1<<log)+1][log];
    }
}
int n;
int lm;
int solve1(int cmax,int cmin,int cl){
    /*int l=cl,r=n;
    while(l<r){
        int m=(l+r)/2;
        if(rmax[m+1]>cmax || lmin[m+1]<cmin){
            l=m+1;
        }else{
            r=m;
        }
    }*/
    lm=max(lm,cl);
    while(lm>cl && rmax[lm]<=cmax && rmin[lm]>=cmin){
        lm--;
    }
    return lm;
}
int ll,lr;
int solve2(int cmax,int cmin,int cl){
    ll=max(ll,cl-1);
    while(ll>cl && rmin[ll]>=cmin){
        ll--;
    }
    //cout<<"maxes: "<<cmax<<" "<<cmin<<endl;
    while(rmax[lr]<cmax){
        lr--;
    }
    //cout<<"ls: "<<ll<<" "<<lr<<" "<<cl<<endl;
    if(lr<=cl || lr<ll){
        //cout<<"wtf"<<endl;
        return -1;
    }
    //cout<<"query"<<query(ll-2,lr-2)<<endl;
    return query(ll-1,lr-2)+1;
}
int main(){
    logs[0]=0;
    logs[1]=0;
    int last=1;
    for(int i=2;i<2000000;i++){
        logs[i]=logs[i-1];
        if(i==last*2){
            logs[i]++;
            last*=2;
        }
    }
    cin>>n;
    ll=n;
    lr=n;
    lm=n;
    for(int i=0;i<n;i++){
        int x,y;
        cin>>x>>y;
        pts.push_back({x,y});
    }
    //sort(pts.begin(),pts.end());
    /*for(int i=0;i<n;i++){
        rminq[i][0]=pts[i].y;
    }
    for(int j=1;j<22;j++){
        for(int i=0;i+(1<<j)<n;i++){
            rminq[i][j]=min(rminq[i][j-1],rminq[i+(1<<j)][j-1]);
        }
    }*/
    lmin[0]=rmin[n+1]=200000000;
    lmax[0]=rmax[n+1]=0;
    for(int i=1;i<=n;i++){
        lmin[i]=min(lmin[i-1],pts[i-1].y);
        lmax[i]=max(lmax[i-1],pts[i-1].y);
    }
    for(int i=n;i>0;i--){
        rmin[i]=min(rmin[i+1],pts[i-1].y);
        rmax[i]=max(rmax[i+1],pts[i-1].y);
    }
    for(int i=2;i<=n;i++){
        vals[i-2]=rmax[i]-(pts[n-1].x-pts[i-2].x);
        rmq[i-2][0]=i-2;
        //cout<<vals[i-2]<<" ";
    }
    //cout<<endl;
    for(int j=1;j<22;j++){
        for(int i=0;i+(1<<j)<=n-1;i++){
            //rminq[i][j]=min(rminq[i][j-1],rminq[i+(1<<j)][j-1]);
            if(vals[rmq[i][j-1]]<vals[rmq[i+(1<<(j-1))][j-1]]){
                rmq[i][j]=rmq[i][j-1];
            }else{
                rmq[i][j]=rmq[i+(1<<(j-1))][j-1];
            }
        }
    }
    for(int j=0;j<3;j++){
        for(int i=0;i+(1<<j)<=n-1;i++){
            //rminq[i][j]=min(rminq[i][j-1],rminq[i+(1<<j)][j-1]);
            //cout<<rmq[i][j]<<" ";
        }
        //cout<<endl;
    }
    int opt=300000000;
    lmin[0]=rmin[n+1]=0;
    for(int i=2;i<n;i++){
        int cmin=lmin[i-1],cmax=lmax[i-1];
        int r1=solve1(cmax,cmin,i);
        //cout<<i<<" "<<r1<<endl;
        opt=min(opt,cmax-cmin+pts[r1-1].x-pts[i-1].x);
        int r2=solve2(cmax,cmin,i);
        if(r2!=-1){
            int ans=rmax[r2+1]-lmin[i-1]+pts[r2-1].x-pts[i-1].x;
            //cout<<i<<" "<<r2<<" "<<ans<<endl;
            opt=min(opt,ans);
        }
    }
    cout<<opt<<endl;
    return 0;
}
