#include<bits/stdc++.h>
using namespace std;

int n;

struct pt
{
    int x, y;
};

vector<pt> pts;

struct ans
{
    int w, h, wx, hy;
};

void printAns(ans a, int i)
{
    cout <<"i = " <<i <<endl;
    cout <<"w = " <<a.w <<endl;
    cout <<"h = " <<a.h <<endl;
    cout <<"wx = " <<a.wx <<endl;
    cout <<"hy = " <<a.hy <<endl;
}

int rec(int i, ans prev)
{
    if(i == n)
    {
        if(prev.wx == -1 || prev.hy == -1)
        {
            return INT_MAX;
        }
        return prev.w + prev.h;
    }
    int wu = max(prev.wx + prev.w, pts[i].x);
    int wd = min(prev.wx, pts[i].x);
    int newWx = wu - wd;
    if(prev.wx == -1) newWx = 0;
    int hu = max(prev.hy + prev.h, pts[i].y);
    int hd = min(prev.hy, pts[i].y);
    int newHy = hu - hd;
    if(prev.hy == -1) newHy = 0;
    /*
    if(newWx + prev.h < newHy + prev.w || (i == n - 1 && prev.wx == -1))
    {

        prev = { newWx, prev.h, wd, prev.hy };
    }
    else
    {
        prev = { prev.w, newHy, prev.wx, hd };
    }*/
    return min(rec(i + 1, { newWx, prev.h, wd, prev.hy }), rec(i + 1, { prev.w, newHy, prev.wx, hd }));
}

//set<int>::iterator i1, i2;
int reccursion(pair<int, int> a, pair<int, int> b, int i = 0)
{
    if(i == n)
    {
        if(a.first == -1 || b.first == -1)
        {
            return INT_MAX;
        }
        return a.second - a.first + b.second - b.first;
    }
    pair<int, int> temp = a;
    a.first = min(a.first, pts[i].x);
    a.second = max(a.second, pts[i].x);
    if(a.first == -1) a.first = pts[i].x;
    int d1 = reccursion(a, b, i + 1);
    a = temp;
    b.first = min(b.first, pts[i].y);
    b.second = max(b.second, pts[i].y);
    if(b.first == -1) b.first = pts[i].y;
    int d2 = reccursion(a, b, i + 1);
    return min(d1, d2);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >>n;
    if(n < 3)
    {
        cout <<0 <<endl;
        return 0;
    }

    pts.resize(n);
    //dp.resize(n);
    for(int i = 0; i < n; i++)
    {
        cin >>pts[i].x >>pts[i].y;
    }
/*
    int c = 0;
    vector<ans> dp(7);
    int mini = INT_MAX, maxi = INT_MIN;
    //dp[0]
    mini = min(pts[0].x, min(pts[1].x, pts[2].x));
    maxi = max(pts[0].x, max(pts[1].x, pts[2].x));
    dp[c++] = { maxi - mini, 0, mini, -1 };
    //dp[1]
    mini = min(pts[1].x, pts[2].x);
    maxi = max(pts[1].x, pts[2].x);
    dp[c++] = { maxi - mini, 0, mini, pts[0].y };
    //dp[2]
    mini = min(pts[0].x, pts[2].x);
    maxi = max(pts[0].x, pts[2].x);
    dp[c++] = { maxi - mini, 0, mini, pts[1].y };
    //dp[3]
    mini = min(pts[0].x, pts[1].x);
    maxi = max(pts[0].x, pts[1].x);
    dp[c++] = { maxi - mini, 0, mini, pts[2].y };
    //dp[4]
    mini = min(pts[1].y, pts[2].y);
    maxi = max(pts[1].y, pts[2].y);
    dp[c++] = { 0, maxi - mini, pts[0].x, mini };
    //dp[5]
    mini = min(pts[0].y, pts[2].y);
    maxi = max(pts[0].y, pts[2].y);
    dp[c++] = { 0, maxi - mini, pts[1].x, mini };
    //dp[6]
    mini = min(pts[0].y, pts[1].y);
    maxi = max(pts[0].y, pts[1].y);
    dp[c++] = { 0, maxi - mini, pts[2].x, mini };
    //dp[7]
    mini = min(pts[0].y, min(pts[1].y, pts[2].y));
    maxi = max(pts[0].y, max(pts[1].y, pts[2].y));
    dp[c++] = { 0, maxi - mini, -1, mini };

    int win = 0, answ = dp[0].w + dp[0].h;
    for(int i = 1; i < dp.size(); i++)
    {
        if(dp[i].w + dp[i].h < answ)
        {
            win = i;
            answ = dp[i].w + dp[i].h;
        }
    }

    int newWx, newHy;
    int wu, wd, hu, hd;
    ans /*next,/ prev = dp[win];
    printAns(prev, 2);
    for(int i = 3; i < n; i++)
    {
        wu = max(prev.wx + prev.w, pts[i].x);
        wd = min(prev.wx, pts[i].x);
        newWx = wu - wd;
        if(prev.wx == -1) newWx = 0;
        hu = max(prev.hy + prev.h, pts[i].y);
        hd = min(prev.hy, pts[i].y);
        newHy = hu - hd;
        if(prev.hy == -1) newHy = 0;
        if(newWx + prev.h < newHy + prev.w || (i == n - 1 && prev.wx == -1))
        {
            prev = { newWx, prev.h, wd, prev.hy };
        }
        else
        {
            prev = { prev.w, newHy, prev.wx, hd };
        }
        printAns(prev, i);
    }

    cout <<prev.w + prev.h <<endl;
    */
    //cout <<rec(0, { 0, 0, -1, -1}) <<endl;
    cout << reccursion({-1, -1}, {-1, -1}, 0) <<endl;
}
