#include<bits/stdc++.h>
using namespace std;

const int nmax=2e6+42;

int n;

pair<int,int> inp[nmax];

int pr_min[nmax],pr_max[nmax],suff_min[nmax],suff_max[nmax];

deque< pair<int/*value*/,int/*id*/> > active[10];

int eval(int i,int j)
{
    if(i==1&&j==n)return 1e9;

    int y_min=1e9,y_max=0;

    if(i>1)
    {
        y_min=min(y_min,pr_min[i-1]);
        y_max=max(y_max,pr_max[i-1]);
    }

    if(j<n)
    {
        y_min=min(y_min,suff_min[j+1]);
        y_max=max(y_max,suff_max[j+1]);
    }

    int score=inp[j].first-inp[i].first+y_max-y_min;

    return score;
}
int eval_1()
{
    int ret=1e9;

    for(int j=1;j<n;j++)
        ret=min(ret,eval(1,j));

    for(int i=1;i<=n;i++)
        ret=min(ret,eval(i,i));

    return ret;
}

int p,q;

void push_frnt(int id,pair<int,int> cur)
{
    active[id].push_front(cur);
}
void push_bck(int id,pair<int,int> cur)
{
    active[id].push_back(cur);
}
void pop_bck(int id,int cur)
{
    if(active[id].size()&&active[id].back().second==cur)active[id].pop_back();
}
void pop_frnt(int id,int cur)
{
    if(active[id].size()&&active[id].front().second==cur)active[id].pop_front();
}

int query(int id)
{
    int ret=1e9;

    for(auto w:active[id])
        ret=min(ret,w.first);

    return ret;
}

int query(int alpha,int beta)
{
    //cout<<"query "<<alpha<<" "<<beta<<endl;

    int score_1=query(1)+alpha-beta;

    int score_2=query(2)+alpha;

    int score_3=query(3);

    int score_4=query(4)-beta;

    //cout<<"scores: "<<score_1<<" "<<score_2<<" "<<score_3<<" "<<score_4<<endl;

    int ret=score_1;
    ret=min(ret,score_2);
    ret=min(ret,score_3);
    ret=min(ret,score_4);

    return ret;
}

int slow()
{
    int ret=1e9;
    for(int i=1;i<=n;i++)
        for(int j=i;j<=n;j++)
            ret=min(ret,eval(i,j));
    return ret;
}
/*
10
1 13
2 3
6 0
10 2
10 0
13 8
14 2
16 15
18 12
22 16
mt19937 rng(48);
*/
int main()
{
    /*
    n=rng()%10+2;
    for(int i=1;i<=n;i++)
    {
        inp[i].first=rng()%5+inp[i-1].first;
        inp[i].second=rng()%20;
    }

    cout<<n<<endl;
    for(int i=1;i<=n;i++)
    {
        cout<<inp[i].first<<" "<<inp[i].second<<endl;
    }
    */

    scanf("%i",&n);
    for(int i=1;i<=n;i++)scanf("%i%i",&inp[i].first,&inp[i].second);

    pr_min[0]=1e9;
    for(int i=1;i<=n;i++)pr_min[i]=min(pr_min[i-1],inp[i].second);
    for(int i=1;i<=n;i++)pr_max[i]=max(pr_max[i-1],inp[i].second);

    suff_min[n+1]=1e9;
    for(int i=n;i>=1;i--)suff_min[i]=min(suff_min[i+1],inp[i].second);
    for(int i=n;i>=1;i--)suff_max[i]=max(suff_max[i+1],inp[i].second);

    int outp=eval_1();

    p=n+1,q=n+1;

    while(pr_max[1]>=suff_max[p]&&p>=2)p--;
    while(pr_min[1]<=suff_min[q]&&q>=2)q--;

    //cout<<p<<" "<<q<<endl;
    for(int j=max(p,q);j<=n;j++)
        push_bck(1,{inp[j].first,j});

    for(int j=p;j<=q-1;j++)
        push_bck(2,{inp[j].first-suff_min[j+1],j});

    for(int j=2;j<=min(p-1,q-1);j++)
        push_bck(3,{inp[j].first+suff_max[j+1]-suff_min[j+1],j});

    for(int j=q;j<=p-1;j++)
        push_bck(4,{inp[j].first+suff_max[j+1],j});

    for(int i=2;i<=n;i++)
    {
        for(int id=1;id<=4;id++)
            pop_frnt(id,i-1);

        if(i>p&&i>q)break;

        while(pr_max[i-1]>=suff_max[p]&&p>=i)
        {
            int mem_p=p;

            p--;

            int j=max(p,q);

            if(max(p,q)<max(mem_p,q))push_frnt(1,{inp[j].first,j});

            j=p;

            if(p<=q-1)push_frnt(2,{inp[j].first-suff_min[j+1],j});

            j=min(q-1,mem_p-1);

            if(min(p-1,q-1)<min(mem_p-1,q-1))pop_bck(3,j);

            j=mem_p;

            if(q<=p-1)pop_bck(4,mem_p-1);
        }

        while(pr_min[i-1]<=suff_min[q]&&q>=i)
        {
            int mem_q=q;

            q--;

            int j=max(p,q);

            if(max(p,q)<max(p,mem_q))push_frnt(1,{inp[j].first,j});

            j=mem_q-1;

            if(p<=j)pop_bck(2,j);

            j=min(p-1,mem_q-1);

            if(min(p-1,q-1)<min(p-1,mem_q-1))pop_bck(3,j);

            j=q;

            if(q<=p-1)push_frnt(4,{inp[j].first+suff_max[j+1],j});
        }

        for(int id=1;id<=4;id++)
        {
            while(active[id].size()&&active[id].front().second<i)pop_frnt(id,active[id].front().second);
        }

        /*
        cout<<"before query "<<endl;
        cout<<"i= "<<i<<" p= "<<p<<" q= "<<q<<endl;
        for(int id=1;id<=4;id++)
        {
            cout<<id<<" -> ";for(auto w:active[id])cout<<w.first<<" "<<w.second<<"\t";
            cout<<endl;
        }
        */

        int score=query(pr_max[i-1],pr_min[i-1])-inp[i].first;

        outp=min(outp,score);

        //cout<<i<<" with "<<score<<endl;
    }

    printf("%i\n",outp);

    //printf("%i\n",slow());

    return 0;
}
/*
11
1 28
5 24
11 14
13 43
19 29
23 6
28 25
36 51
39 32
44 29
50 21

1 1 -> 45
1 2 -> 49
1 3 -> 55
1 4 -> 57
1 5 -> 63
1 6 -> 52
1 7 -> 57
1 8 -> 46
1 9 -> 46
1 10 -> 43

2 2 -> 45
2 3 -> 51
2 4 -> 53
2 5 -> 59
2 6 -> 48
2 7 -> 53
2 8 -> 42
2 9 -> 42
2 10 -> 46
2 11 -> 45

3 3 -> 45
3 4 -> 47
3 5 -> 53
3 6 -> 42
3 7 -> 47
3 8 -> 36
3 9 -> 36
3 10 -> 40
3 11 -> 43

4 4 -> 45
4 5 -> 51
4 6 -> 47
4 7 -> 52
4 8 -> 41
4 9 -> 41
4 10 -> 45
4 11 -> 51

5 5 -> 45
5 6 -> 41
5 7 -> 46
5 8 -> 46
5 9 -> 49
5 10 -> 54
5 11 -> 60

6 6 -> 37
6 7 -> 42
6 8 -> 42
6 9 -> 45
6 10 -> 50
6 11 -> 56

7 7 -> 45
7 8 -> 45
7 9 -> 48
7 10 -> 53
7 11 -> 59

8 8 -> 37
8 9 -> 40
8 10 -> 45
8 11 -> 51

9 9 -> 45
9 10 -> 50
9 11 -> 56

10 10 -> 45
10 11 -> 51

11 11 -> 45
*/
