#include<bits/stdc++.h>
using namespace std;

const int nmax=2e6+42;

int n;

pair<int,int> inp[nmax];

int pr_min[nmax],pr_max[nmax],suff_min[nmax],suff_max[nmax];

deque< pair<int/*value*/,int/*id*/> > active[2][10],help;
deque< int/*min_value*/> mem_mini[2][10];

int eval(int i,int j)
{
    if(i==1&&j==n)return 1e9;

    int y_min=1e9,y_max=0;

    if(i>1)
    {
        y_min=min(y_min,pr_min[i-1]);
        y_max=max(y_max,pr_max[i-1]);
    }

    if(j<n)
    {
        y_min=min(y_min,suff_min[j+1]);
        y_max=max(y_max,suff_max[j+1]);
    }

    int score=inp[j].first-inp[i].first+y_max-y_min;

    return score;
}
int eval_1()
{
    int ret=1e9;

    for(int j=1;j<n;j++)
        ret=min(ret,eval(1,j));

    for(int i=1;i<=n;i++)
        ret=min(ret,eval(i,i));

    return ret;
}

int p,q;

void push_frnt(int id,pair<int,int> cur)
{
    int to_add=1e9;
    if(mem_mini[0][id].size())to_add=mem_mini[0][id][0];

    active[0][id].push_front(cur);
    to_add=min(to_add,cur.first);

    mem_mini[0][id].push_front(to_add);
}
void push_bck(int id,pair<int,int> cur)
{
    int to_add=1e9;
    if(mem_mini[1][id].size())to_add=mem_mini[1][id].back();

    active[1][id].push_back(cur);
    to_add=min(to_add,cur.first);

    mem_mini[1][id].push_back(to_add);
}

void rebuild(int id)
{
    /*
    cout<<"rebuild "<<id<<endl;
    cout<<"-----"<<endl;
    */
    help=active[0][id];

    mem_mini[0][id]={};
    mem_mini[1][id]={};

    for(auto w:active[1][id])
        help.push_back(w);

    active[0][id]={};
    active[1][id]={};

    int av=help.size()/2;

    if(help.size()==0)return;

    for(int i=av;i>=0;i--)
        push_frnt(id,help[i]);

    for(int i=av+1;i<help.size();i++)
        push_bck(id,help[i]);

}
void pop_bck(int id,int cur)
{
    //cout<<"pop_bck "<<id<<" "<<cur<<endl;

    if(active[1][id].size())
    {
        //cout<<"actually: "<<active[1][id].back().second<<endl;

        if(active[1][id].back().second==cur)
        {
            active[1][id].pop_back();
            mem_mini[1][id].pop_back();
        }

        return;
    }

    //cout<<"is: "<<active[0][id].back().second<<endl;

    if(active[0][id].size()&&active[0][id].back().second==cur)
    {
        //cout<<"gaz rebuild"<<endl;

        active[0][id].pop_back();
        rebuild(id);
    }
}
void pop_frnt(int id,int cur)
{
    //cout<<"pop_frnt "<<id<<" "<<cur<<endl;

    if(active[0][id].size())
    {
        if(active[0][id].front().second==cur)
        {
            active[0][id].pop_front();
            mem_mini[0][id].pop_front();
        }

        return;
    }

    if(active[1][id].size()&&active[1][id].front().second==cur)
    {
        active[1][id].pop_front();
        rebuild(id);
    }
}

int query(int id)
{
    int ret=1e9;

    if(mem_mini[0][id].size())ret=min(ret,mem_mini[0][id][0]);
    if(mem_mini[1][id].size())ret=min(ret,mem_mini[1][id].back());

    return ret;
}

int query(int alpha,int beta)
{
    //cout<<"query "<<alpha<<" "<<beta<<endl;

    int score_1=query(1)+alpha-beta;

    int score_2=query(2)+alpha;

    int score_3=query(3);

    int score_4=query(4)-beta;

    //cout<<"scores: "<<score_1<<" "<<score_2<<" "<<score_3<<" "<<score_4<<endl;

    int ret=score_1;
    ret=min(ret,score_2);
    ret=min(ret,score_3);
    ret=min(ret,score_4);

    return ret;
}

int slow()
{
    int ret=1e9;
    for(int i=1;i<=n;i++)
        for(int j=i;j<=n;j++)
            ret=min(ret,eval(i,j));
    return ret;
}
/*
10
1 13
2 3
6 0
10 2
10 0
13 8
14 2
16 15
18 12
22 16
mt19937 rng(48);
*/
int main()
{
    /*
    n=rng()%10+2;
    for(int i=1;i<=n;i++)
    {
        inp[i].first=rng()%5+inp[i-1].first;
        inp[i].second=rng()%20;
    }

    cout<<n<<endl;
    for(int i=1;i<=n;i++)
    {
        cout<<inp[i].first<<" "<<inp[i].second<<endl;
    }
    */

    scanf("%i",&n);
    for(int i=1;i<=n;i++)scanf("%i%i",&inp[i].first,&inp[i].second);

    pr_min[0]=1e9;
    for(int i=1;i<=n;i++)pr_min[i]=min(pr_min[i-1],inp[i].second);
    for(int i=1;i<=n;i++)pr_max[i]=max(pr_max[i-1],inp[i].second);

    suff_min[n+1]=1e9;
    for(int i=n;i>=1;i--)suff_min[i]=min(suff_min[i+1],inp[i].second);
    for(int i=n;i>=1;i--)suff_max[i]=max(suff_max[i+1],inp[i].second);

    int outp=eval_1();

    p=n+1,q=n+1;

    while(pr_max[1]>=suff_max[p]&&p>=2)p--;
    while(pr_min[1]<=suff_min[q]&&q>=2)q--;

    //cout<<p<<" "<<q<<endl;
    for(int j=max(p,q);j<=n;j++)
        push_bck(1,{inp[j].first,j});

    for(int j=p;j<=q-1;j++)
        push_bck(2,{inp[j].first-suff_min[j+1],j});

    for(int j=2;j<=min(p-1,q-1);j++)
        push_bck(3,{inp[j].first+suff_max[j+1]-suff_min[j+1],j});

    for(int j=q;j<=p-1;j++)
        push_bck(4,{inp[j].first+suff_max[j+1],j});

    for(int i=2;i<=n;i++)
    {
        for(int id=1;id<=4;id++)
            pop_frnt(id,i-1);

        if(i>p&&i>q)break;

        while(pr_max[i-1]>=suff_max[p]&&p>=i)
        {
            int mem_p=p;

            p--;

            int j=max(p,q);

            if(max(p,q)<max(mem_p,q))push_frnt(1,{inp[j].first,j});

            j=p;

            if(p<=q-1)push_frnt(2,{inp[j].first-suff_min[j+1],j});

            j=min(q-1,mem_p-1);

            if(min(p-1,q-1)<min(mem_p-1,q-1))pop_bck(3,j);

            j=mem_p;

            if(q<=mem_p-1)pop_bck(4,mem_p-1);
        }

        while(pr_min[i-1]<=suff_min[q]&&q>=i)
        {
            int mem_q=q;

            q--;

            int j=max(p,q);

            if(max(p,q)<max(p,mem_q))push_frnt(1,{inp[j].first,j});

            j=mem_q-1;

            if(p<=j)pop_bck(2,j);

            j=min(p-1,mem_q-1);

            if(min(p-1,q-1)<min(p-1,mem_q-1))pop_bck(3,j);

            j=q;

            if(q<=p-1)push_frnt(4,{inp[j].first+suff_max[j+1],j});
        }

        for(int id=1;id<=4;id++)
        {
            bool go=1;

            /*
            cout<<"i= "<<i<<endl;
            cout<<id<<" -> left: ";for(auto w:active[0][id])cout<<w.first<<" "<<w.second<<"\t";cout<<"right: ";for(auto w:active[1][id])cout<<w.first<<" "<<w.second<<"\t";
            cout<<"\nmem_mini -> left: ";for(auto w:mem_mini[0][id])cout<<w<<"\t";cout<<"right: ";for(auto w:mem_mini[1][id])cout<<w<<"\t";
            */

            while(go)
            {
                go=0;

                if(active[0][id].size()&&active[0][id].front().second<i)
                {
                    pop_frnt(id,active[0][id].front().second);
                    go=1;
                }

                else if(active[1][id].size()&&active[1][id].front().second<i)
                {
                    pop_frnt(id,active[1][id].front().second);
                    go=1;
                }
            }
        }

        /*
        cout<<"before query "<<endl;
        cout<<"i= "<<i<<" p= "<<p<<" q= "<<q<<endl;
        for(int id=1;id<=4;id++)
        {
            cout<<id<<" -> left: ";for(auto w:active[0][id])cout<<w.first<<" "<<w.second<<"\t";cout<<"right: ";for(auto w:active[1][id])cout<<w.first<<" "<<w.second<<"\t";
            cout<<"\nmem_mini -> left: ";for(auto w:mem_mini[0][id])cout<<w<<"\t";cout<<"right: ";for(auto w:mem_mini[1][id])cout<<w<<"\t";

            cout<<endl;
        }
        */

        int score=query(pr_max[i-1],pr_min[i-1])-inp[i].first;

        outp=min(outp,score);

        //cout<<i<<" with "<<score<<endl;
    }

    printf("%i\n",outp);

    //printf("%i\n",slow());

    return 0;
}
/*
11
1 28
5 24
11 14
13 43
19 29
23 6
28 25
36 51
39 32
44 29
50 21
*/
/*
7
2 18
4 30
7 33
8 6
8 6
11 21
11 18
*/
/*
10
3 3
4 16
7 17
11 11
15 1
16 7
16 4
19 6
22 1
22 14
*/
