#include<bits/stdc++.h>
using namespace std;

const int nmax=3e5+42;

int hills,inp[nmax];

int f;
pair<int/*h*/,int/*forced?*/> forced[nmax];

long long at_least,at_most;

long long delta;

void run_up(int id_l,int id_r)
{
    int l=inp[id_l];
    int r=inp[id_r];

    if(forced[l].second)at_most=min(at_most,1LL*forced[l].first);

    if(forced[r].second)at_least=max(at_least,1LL*forced[r].first-delta);

    for(int j=l+1;j<r;j++)
        {
            if(forced[j].second)
            {
                at_most=min(at_most,1LL*forced[j].first+l-j);
                at_least=max(at_least,1LL*forced[j].first+r-j-delta);
            }
        }
}

void run_down(int id_l,int id_r)
{
    int l=inp[id_l];
    int r=inp[id_r];

    if(forced[l].second)at_least=max(at_least,1LL*forced[l].first-delta);

    if(forced[r].second)at_most=min(at_most,1LL*forced[r].first);

    for(int j=l+1;j<r;j++)
        {
            if(forced[j].second)
            {
                at_most=min(at_most,1LL*forced[j].first+j-r);
                at_least=max(at_least,1LL*forced[j].first-delta+j-l);
            }
        }
}

long long h[nmax];

pair<long long,int> construct(long long low)
{
    memset(h,0,sizeof(h));

    for(int i=1;i<=inp[hills];i++)
        if(forced[i].second)h[i]=forced[i].first;

    //cout<<"h: ";for(int i=1;i<=inp[hills];i++)cout<<h[i]<<" ";cout<<endl;

    for(int i=1;i<=hills;i=i+2)
    {
        if(forced[inp[i]].second==0)h[inp[i]]=low;

        if(i<hills)
        {
            for(int j=inp[i]+1;j<inp[i+1];j++)
            {
                long long h_now=h[j-1]+1;

                if(forced[j].second==0)
                {
                    h[j]=h_now;
                    continue;
                }

                if(forced[j].second&&forced[j].first<h_now)return {-1,0};

                h[j]=forced[j].first;
            }
        }

        if(i>1)
        {
            for(int j=inp[i]-1;j>inp[i-1];j--)
            {
                long long h_now=h[j+1]+1;

                if(forced[j].second==0)
                {
                    h[j]=h_now;
                    continue;
                }

                if(forced[j].second&&forced[j].first<h_now)return {-1,0};

                h[j]=forced[j].first;
            }
        }

        //cout<<"i= "<<i<<" : ";for(int i=1;i<=inp[hills];i++)cout<<h[i]<<" ";cout<<endl;
    }

    //cout<<"wrong= "<<low<<" : ";for(int i=1;i<=inp[hills];i++)cout<<h[i]<<" ";cout<<endl;

    for(int i=2;i<=hills;i+=2)
    {
        int j=inp[i];

        h[j]=max(h[j],max(h[j-1]+1,h[j+1]+1));
    }

    long long maxi=h[1],mini=h[1];

    for(int i=1;i<=inp[hills];i++)
    {
        maxi=max(maxi,h[i]);
        mini=min(mini,h[i]);
    }

    if(maxi-mini>delta)return {-1,0};

    //cout<<"delta= "<<delta<<" low= "<<low<<" : ";for(int i=1;i<=inp[hills];i++)cout<<h[i]<<" ";cout<<endl;

    long long sum=0;
    for(int i=1;i<=inp[hills];i++)
        sum+=h[inp[i]];

    return {sum,1};
}

pair<long long,int> get_any(long long down,long long up)
{

    while(down<up-3)
    {
        //cout<<down<<" "<<up<<endl;

        long long av=(down+up)/2;

        //cout<<"av= "<<av<<endl;

        pair<long long,int> cur=construct(av);

        if(cur.second)up=av;
        else down=av+1;
    }

    while(down<=up)
    {
        long long av=down;

        pair<long long,int> cur=construct(av);

        if(cur.second)return cur;
        else down++;
    }

    return {0,0};
}
bool valid(long long cur)
{
    delta=cur;

    at_least=-2e9,at_most=2e9;

    for(int i=1;i<=inp[hills];i++)
        if(forced[i].second)
        {
            at_least=max(at_least,forced[i].first-delta);
            at_most=min(at_most,1LL*forced[i].first);
        }

    for(int i=1;i<hills;i++)
        if(i%2==1)run_up(i,i+1);
        else run_down(i,i+1);

    //cout<<delta<<" "<<at_least<<" "<<at_most<<endl;

    delta=cur;
    if(at_least<=at_most)return get_any(at_least,at_most).second;

    return 0;
}

int main()
{
    scanf("%i",&hills);
    for(int i=1;i<=hills;i++)scanf("%i",&inp[i]);

    scanf("%i",&f);
    for(int i=1;i<=f;i++)
    {
        int node,h;
        scanf("%i%i",&node,&h);
        forced[node]={h,1};
    }

    long long ok=5e9,not_ok=-1;

    for(int i=1;i<hills;i++)
        not_ok=max(not_ok,inp[i+1]-inp[i]-1LL);

    for(ok=not_ok+1;true;ok++)
    {
        if(valid(ok))
        {
            printf("%lld %lld\n",ok,get_any(at_least,at_most).first);
            exit(0);
        }
    }

    //printf("%i\n",brute());

    return 0;
}
/*
7
1 2 4 7 9 11 14
1
6 6

3 29

2
1 10
2
1 -5
5 5

15 5

3
1 2 3
3
1 4
2 100
3 1

96 0


4
1 4 7 100
3
4 4
6 -10
8 -20

3
1 2 3
2
1 -2
3 -7
*/