#include<iostream>
#include<algorithm>
using namespace std;

const int MAXN = 1000002;
const int INF = 1000000000;

int n;
pair<int, int> points[MAXN];
int answ=INF;

void solve(int p, int a1, int a2, int b1, int b2)
{
    if(p==n)
    {
        if(a1!=(-1) && b1!=(-1))
        {
            answ=min(answ, (a2-a1+b2-b1));
        }
        return;
    }

    int a1pr=a1, a2pr=a2;

    if(!(points[p].second>b1 && b2>points[p].second))
    {
        /// a:
        if(a1 == (-1)) a1=points[p].first;
        a2=points[p].first;

        solve(p+1, a1, a2, b1, b2);

        a1=a1pr; a2=a2pr;
    }

    /// b:
    if(b1 == (-1))
    {
        b1=points[p].second;
        b2=points[p].second;
    }
    else
    {
        b1=min(b1, points[p].second);
        b2=max(b2, points[p].second);
    }

    solve(p+1, a1, a2, b1, b2);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n;
    for(int i=0; i<n; ++i)
    {
        cin>>points[i].first>>points[i].second;
    }

    solve(0, -1, -1, -1, -1);

    cout<<answ<<endl;

    return 0;
}
