#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<pair<int, int>> points;

void read() {
    cin >> n;

    points.resize(n);
    for (auto &i : points) {
        cin >> i.first >> i.second;
    }
}

void solve() {
    int answer = 1e9;

    for (int mask = 1; mask < (1 << n) - 1; mask++) {
        int minX = 1e9, maxX = -1e9, minY = 1e9, maxY = -1e9;

        for (int i = 0; i < n; i++) {
            if (!(mask & (1 << i))) {
                minX = min(minX, points[i].first);
                maxX = max(maxX, points[i].first);
            } else {
                minY = min(minY, points[i].second);
                maxY = max(maxY, points[i].second);
            }
        }

        answer = min(answer, maxX - minX + maxY - minY);
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
