#include<iostream>
#include<cstdio>
#include<algorithm>
using namespace std;

struct point
{
	int x,y;
};

int n;
point p[300000];

int mod(int a, int b)
{
	return max(a,b) - min(a,b);
}

pair<int, int> get_mm(int l, int r)
{
	if(l < 0 || r == n) return make_pair(1e9,-1);
	
	int mine = p[l].y; 
	int maxe = p[l].y;
	for(int i = l+1; i <= r; i++) 
	{
		mine = min(mine, p[i].y);
		maxe = max(maxe, p[i].y);
	}
	return make_pair(mine,maxe);
}

int main()
{
	scanf("%d",&n);
	for(int i = 0; i < n; i++)
	{
		scanf("%d%d",&p[i].x,&p[i].y);
	}
	if(n == 2)
	{
		int a = p[0].x + p[1].y;
		int b = p[0].y + p[1].x;
		printf("%d\n",min(a,b));
	}
	else
	{
		int cur_sol = 0, sol = -1;
		
		//corner cases
		int opt = min(p[n-1].y, mod(p[n-1].y, p[n-3].y) );
		int opt2 = min(p[0].y, mod(p[2].y, p[0].y));
		
		for(int i = n-4; i > 0; i--) 
		{
			opt = min(opt,mod(p[n-1].y, p[i].y) );
		}
		for(int i = 4; i < n-1; i++)
		{
			opt2 = min(opt2, mod(p[i].y,p[0].y) );
		}
		printf("opt = %d\n",opt);
		
		//alice
		for(int l = 0; l < n; l++)
		{
			for(int r = l; r < n; r++)
			{
				pair<int, int> op, op2;
				
				op.first = op2.first = 1e9;
				op.second = op.second = -1;
				
				if(l == 0 && r == n-1) continue;
				
				if( l==r ) cur_sol = p[l].x;
				else
				{
					cur_sol = p[r].x - p[l].x;	
				}
				//printf("l = %d r=%d\n",l,r);
				//printf("cur_sol = %d\n",cur_sol);
				
				if(l > 0) op = get_mm(0,l-1);
				if(r < n-1) op2 = get_mm(r+1,n-1);
				
				if(r == n-2 && l == 0) 
				{
					op2 = make_pair(0,opt);
					op = make_pair(0,0);
				}
				if(l == 1 && r == n-1) 
				{
					op = make_pair(0,0);
					op2 = make_pair(0,opt2);
				}
				
				cur_sol += (max(op.second,op2.second) - min(op.first,op2.first));
				
				//printf("op2.first = %d op2.second = %d\n",op2.first, op2.second);
				//printf("op.first = %d op.second = %d\n",op.first,op.second);
				//printf("cur_sol = %d\n",cur_sol);
				
				if(sol == -1) sol = cur_sol;
				else sol = min(sol, cur_sol);
			}
		}
		printf("%d\n",sol);
	}
}
/*
4
1 28
5 24
11 14
13 30
*/
