#include<bits/stdc++.h>
using namespace std;

int const maxn = 1e6;
int const inf = (1<<31) - 1 ;

int x[maxn],y[maxn];
struct SG_tree
{
    struct node
    {
        int mn,mx;
        node(){}
        node(int _n, int _x)
        {
            mn = _n; mx = _x;
        }
    };

    int n;
    vector<node>tree;

    SG_tree(){}
    SG_tree(int nn)
    {
        n = nn;
        tree.resize(8*nn);
    }

    void make_tree(int k, int l, int r)
    {
        if(l == r)
        {
            tree[k] = node(y[l],y[l]);
            //cout<<k<<" "<<l<<" "<<r<<" : "<<tree[k].mn<<" "<<tree[k].mx<<endl;
            return;
        }

        make_tree(k*2,l,(l+r)/2);
        make_tree(k*2+1,(l+r)/2+1,r);

        tree[k].mn = min(tree[k*2].mn,tree[k*2+1].mn);
        tree[k].mx = max(tree[k*2].mx,tree[k*2+1].mx);

        //cout<<k<<" "<<l<<" "<<r<<" : "<<tree[k].mn<<" "<<tree[k].mx<<endl;
    }

    void build()
    {
        make_tree(1,1,n);
    }

    node real_ans(int k,int l,int r,int x,int y)
    {
        //if((x == 1 && y == 2) || (x == 9 && y == 11))cout<<"  "<<k<<" "<<l<<" "<<r<<endl;
        if(x<=l && r<=y)
            return tree[k];

        if(l>y || r<x || y<x)
        {
            return node(-1,-1);
        }

        int mid = (l+r)/2;
        node nl,nr;

        nl = real_ans(k*2,l,mid,x,y);
        nr = real_ans(k*2+1,mid+1,r,x,y);

        if(nl.mx == -1)
            return nr;
        if(nr.mx == -1)
            return nl;

        nl.mn = min(nl.mn, nr.mn);
        nl.mx = max(nl.mx, nr.mx);

        return nl;
    }

    int get_ans(int x, int y)
    {
        //cout<<x<<" "<<y<<endl;
        node nl = real_ans(1,1,n,1,x-1);
        node nr = real_ans(1,1,n,y+1,n);
        //cout<<" "<<nl.mn<<" "<<nl.mx<<endl;
        //cout<<" "<<nr.mn<<" "<<nr.mx<<endl;

        if(nl.mx == -1)
            return nr.mx - nr.mn;
        if(nr.mx == -1)
            return nl.mx - nl.mn;

        nl.mn = min(nl.mn, nr.mn);
        nl.mx = max(nl.mx, nr.mx);

        return nl.mx - nl.mn;
    }
};

SG_tree T;
int n,ans = inf;

int main()
{
    int i,j;
    cin>>n;
    T = SG_tree(n);

    for(i=1;i<=n;i++)
        cin>>x[i]>>y[i];

    T.build();
    for(i=1; i<n; i++)
    {
        for(j=i+1; j<=n; j++)
        {
            ans = min(x[j] - x[i] + T.get_ans(i,j),ans);
        }
    }

    cout<<ans<<"\n";
    return 0;
}
