#include<iostream>
#include<cstdio>
#include<vector>
#include<climits>
#include<set>

using namespace std;

int n;
vector<pair<int, int> > points;

set<pair<pair<int, int>, pair<int, int> > > candidates;

int main ()
{
    candidates.emplace(make_pair(INT_MIN, INT_MAX), make_pair(INT_MIN, INT_MAX));

    scanf("%d", &n);
    for (int i=0; i<n; i++)
    {
        int x, y;
        scanf("%d%d", &x, &y);

        set<pair<pair<int, int>, pair<int, int> > > nextStep;
        for (auto a : candidates)
        {
            pair<pair<int, int>, pair<int, int> > sx, sy;

            if (a.first.first == INT_MIN || a.first.second == INT_MAX)
            {
                sx = make_pair(make_pair(x, x), make_pair(a.second.first, a.second.second));
            }
            else
            {
                if (x < a.first.first) sx = make_pair(make_pair(x, a.first.second), a.second);
                else if (x > a.first.second) sx = make_pair(make_pair(a.first.first, x), a.second);
                else
                {
                    nextStep.insert(a);
                    continue;
                }
            }

            if (a.second.first == INT_MIN || a.second.second == INT_MAX)
            {
                sy = make_pair(a.first, make_pair(y, y));
            }
            else
            {
                if (y < a.second.first) sy = make_pair(a.first, make_pair(y, a.second.second));
                else if (y > a.second.second) sy = make_pair(a.first, make_pair(a.second.first, y));
                else
                {
                    nextStep.insert(a);
                    continue;
                }
            }

            nextStep.insert(sx);
            nextStep.insert(sy);
        }
        candidates = nextStep;
    }

    int ans = INT_MAX;

    for (auto a : candidates)
    {
        int val = a.first.second + a.second.second - a.first.first - a.second.first;
        if (val < ans) ans = val;
    }

    cout<<ans<<endl;
}
