#include <iostream>

using namespace std;

const int MAXN = 3e5 + 5;
const int offset = 100;

int n;
int h[MAXN];
bool isSpecial[MAXN];

bool used[2*offset];

int a[MAXN];
bool checkSpecial(int ind)
{
    if(ind==0) return a[0]<a[1];
    if(ind==n-1) return true;

    return ((a[ind-1]<a[ind] && a[ind]>a[ind+1]) || (a[ind-1]>a[ind] && a[ind]<a[ind+1]));
}

int minDiff = offset*5;
int minSum = offset*69;

void rec(int ind)
{
    //if(ind>3) cout << " -> " << ind << '\n';

    if(ind==n)
    {
        int sum = 0;
        int minVal = offset*2, maxVal = -offset*2;

        for(int i = 0;i<n;i++)
        {
            if(isSpecial[i]==true) sum += a[i];
            minVal = min(minVal, a[i]);
            maxVal = max(maxVal, a[i]);
        }

        if(maxVal-minVal<minDiff)
        {
            minDiff = maxVal - minVal;
            minSum = sum;

            //cout << checkSpecial(0) << " " << isSpecial[0] << '\n';
            //for(int i = 0;i<n;i++) cout << a[i] << " ";
            //cout << '\n';
        }
        else if(maxVal-minVal==minDiff)
        {
            minSum = min(minSum, sum);
        }

        return;
    }

    for(int x = -12;x<=12;x++)
    {
        //if(used[x+offset]==true) continue;
        if(h[ind]!=-1 && x!=h[ind]) continue;

        a[ind] = x;
        if(ind>0 && a[ind-1]==a[ind]) continue;
        if(ind>0 && isSpecial[ind-1]!=checkSpecial(ind-1))
        {
            continue;
        }

        used[x+offset] = true;
        rec(ind+1);
        used[x+offset] = false;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int T;
    cin >> T;

    while(T--)
    {
        int x;
        cin >> x;

        n = x;
        isSpecial[x-1] = true;
    }

    for(int i = 0;i<n;i++) h[i] = -1;

    cin >> T;
    while(T--)
    {
        int ind, curr;
        cin >> ind >> curr;ind--;

        h[ind] = curr;
    }

    rec(0);
    cout << minDiff << " " << minSum << '\n';
}
