#include <iostream>
#include <algorithm>
#include <vector>
#include <string.h>
using namespace std;
#define endl '\n'
const int MAXN=3e5+10;
int beg[MAXN], type[MAXN];
long long val[MAXN];
bool used[MAXN], isv[MAXN], never[MAXN];
vector <int> points, low, high;
vector <pair <int,long long> > v[MAXN];
void construct_graph() {
    int curt=-1;
    for (int i=0;i<points.size()-1;i++) {
        if (curt==-1) curt=type[points[i]];
        else if (type[points[i]]!=0) curt=type[points[i]];
        int dif=points[i+1]-points[i];
        if (curt==2) dif=-dif;
        v[points[i]].push_back({points[i+1],dif});
        v[points[i+1]].push_back({points[i],-dif});
    }
}
void value(int x, long long st) {
    if (!never[x]) {
        val[x]=st;
        never[x]=true;
        return;
    }
    if (type[x]==1) val[x]=min(val[x],st);
    else val[x]=max(val[x],st);
}
void dfs(int x, long long curval) {
    if (!isv[x]) value(x,curval);
    ///cout << x << ' ' << curval << ' ' << val[x] << endl;
    curval=val[x];
    used[x]=true;
    for (auto i:v[x]) {
        if (used[i.first]) continue;
        dfs(i.first,curval+i.second);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t, n, w, p;
    long long a;
    int curt=1;
    cin >> t;
    for (int i=0;i<t;i++) {
        cin >> p;
        type[p]=curt;
        if (curt==1) low.push_back(p);
        else high.push_back(p);
        points.push_back(p);
        if (curt==1) curt=2;
        else curt=1;
    }
    cin >> w;
    for (int i=0;i<w;i++) {
        cin >> beg[i] >> a;
        val[beg[i]]=a;
        isv[beg[i]]=true;
        never[beg[i]]=true;
        if (type[beg[i]]==0) points.push_back(beg[i]);
    }
    sort(points.begin(),points.end());
    construct_graph();
    for (int i=0;i<w;i++) {
        memset(used,false,sizeof(used));
        dfs(beg[i],val[beg[i]]);
    }
    long long sum, maxx, minx;
    minx=1e9;
    maxx=-1e9;
    sum=0;
    for (auto i:low) minx=min(minx,val[i]);
    for (auto i:high) {
        maxx=max(maxx,val[i]);
        sum+=val[i];
    }
    for (auto i:low) {
        if (isv[i]) sum+=val[i];
        else sum+=minx;
    }
    cout << maxx-minx << ' ' << sum << endl;
    return 0;
}
/**
7
1 2 4 7 9 11 14
2
5 -1
8 6
**/
