#include<bits/stdc++.h>
#define mogila 1
#define dolina -1
using namespace std;

const int MAXN = 30000;
const int INF = 1e+9+1;

int whatIsThis[MAXN+1], whatIsLast = mogila;
int minGivenValue = INF, maxGivenValue = -INF, minGivenVIndex = -1, maxGivenVIndex = -1;

vector<pair<int, int>> mogilasCount;
map<int, int> mogilaToIndex;
queue<int> knownPoints;
vector<int> indsToCheck;

int t, n, w, siz;

void INPUT()
{
    memset(whatIsThis, 0, sizeof(whatIsThis));
    cin >> t;
    for(int i = 0; i < t; i++)
    {
        cin >> n;
        if(whatIsLast == mogila) whatIsThis[n] = dolina;
        else whatIsThis[n] = mogila;
        whatIsLast *= -1;
        mogilaToIndex[n] = mogilasCount.size()+1;
        mogilasCount.push_back({n, INF*whatIsThis[n]});
    }

    cin >> w;
    int node, height;
    for(int i = 0; i < w; i++)
    {
        cin >> node >> height;
        if(mogilaToIndex[node] != 0) mogilasCount[mogilaToIndex[node]-1].second = height;
        else mogilasCount.push_back({node, height});
    }

    sort(mogilasCount.begin(), mogilasCount.end());

    siz = mogilasCount.size();
    for(int i = 0; i < siz; i++)
    {
        if(mogilasCount[i].second != INF && mogilasCount[i].second != -INF)
        {
            indsToCheck.push_back(i);
        }
    }
}

void CalculateValueForIndex(int index, pair<int, int> knownPoint)
{
    if(whatIsThis[mogilasCount[index].first] != mogila && whatIsThis[mogilasCount[index].first] != dolina) return;
    if(mogilasCount[index].second == INF || mogilasCount[index].second == -INF)
    {
        mogilasCount[index].second = knownPoint.second + abs(mogilasCount[index].first-knownPoint.first) * whatIsThis[mogilasCount[index].first];
        return;
    }
    if(whatIsThis[mogilasCount[index].first] == mogila)
        mogilasCount[index].second = max(mogilasCount[index].second, knownPoint.second + abs(mogilasCount[index].first-knownPoint.first));
    else mogilasCount[index].second = min(mogilasCount[index].second, knownPoint.second - abs(mogilasCount[index].first-knownPoint.first));
}

void WaveCalculateValues(int startIndex)
{
    queue<int> ind;
    ind.push(startIndex);
    while(!ind.empty())
    {
        int top = ind.front();
        ind.pop();

        if(top > 0)
        {
            CalculateValueForIndex(top-1, mogilasCount[top]);
            if(top <= startIndex)
                ind.push(top-1);
        }
        if(top < siz-1)
        {
            CalculateValueForIndex(top+1, mogilasCount[top]);
            if(top >= startIndex)
                ind.push(top+1);
        }
    }
    //cout << "debug" << "\n";
}

void Solve()
{
    //cout << minGivenVIndex << " " << mogilasCount[minGivenVIndex].first << " " << mogilasCount[minGivenVIndex].second << endl;
    for(int e : indsToCheck) WaveCalculateValues(e);
    for(int i = 0; i < siz; i++)
    {
        //if(whatIsThis[mogilasCount[i].first] == mogila || whatIsThis[mogilasCount[i].first] == dolina)
        //{
            minGivenValue = min(minGivenValue, mogilasCount[i].second);
            maxGivenValue = max(mogilasCount[i].second, maxGivenValue);
        //}
    }
    int s = 0;
    for(int i = 0; i < siz; i++)
    {
        if(whatIsThis[mogilasCount[i].first] == dolina)
            s += min(mogilasCount[i].second, minGivenValue);
        if(whatIsThis[mogilasCount[i].first] == mogila)
            s += mogilasCount[i].second;
    }
    cout << maxGivenValue-minGivenValue << " " << s << endl;
}

int main()
{
    INPUT();
    Solve();
    return 0;
}
