#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

struct point
{
    long long x;
    long long y;
};

const int MAXN=1e5, MAX_HEIGHT=1e8;
const long long MAX_SUM=1e15;

long long minSum=MAX_SUM;
point points[MAXN];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    for(int i=0; i<n; i++)
    {
        cin >> points[i].x >> points[i].y;
    }

    for(int i=0; i<n; i++)
    {
        for(int j=i; j<n; j++)
        {
            if(i==0 && j==n-1)
            {
                continue;
            }

            long long highest=0, lowest=MAX_HEIGHT;
            for(int k=0; k<n; k++)
            {
                if(k>=i && k<=j)
                {
                    continue;
                }

                highest=max(highest, points[k].y);
                lowest=min(lowest, points[k].y);
            }

            minSum=min(minSum, (points[j].x-points[i].x)+(highest-lowest));
        }
    }

    cout << minSum << "\n";

    return 0;
}

/*
5
1 1
1 20
3 3
5 5
23 4
*/
