#pragma GCC optimize("O3")
#pragma GCC optimize("sse4")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long int
#define ld long double
#define bit(idx) idx&(-idx)
#define bin(x) bitset<32>(x).to_string()
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>
#define ordered_set_T ll

using namespace std;
using namespace __gnu_pbds;

typedef tree<ordered_set_T, null_type, less<ordered_set_T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x) -> how many elements are smaller than x

const ll MAXN = 1e6 + 6;
const ll MAXLOG = 24;
const ll MIN = 0;
const ll MAX = 1;

ll n, A[MAXN][2];
pair<ll, ll> segmtree[2][4 * MAXN];

void build(int node = 1, int l = 1, int r = n){
    if(l == r){
        segmtree[MIN][node] = {A[l][1], l};
        segmtree[MAX][node] = {A[l][1], l};
    }
    else{
        int m = (l + r) / 2;
        build(2 * node, l, m);
        build(2 * node + 1, m + 1, r);
        segmtree[MAX][node] = max(segmtree[MAX][2 * node], segmtree[MAX][2 * node + 1]);
        segmtree[MIN][node] = min(segmtree[MIN][2 * node], segmtree[MIN][2 * node + 1]);
    }
}

pair<ll, ll> qry(ll node, ll l, ll r, ll ql, ll qr, ll t){
    if(qr < l || r < ql){
        return (t == MIN ? make_pair(LLONG_MAX, -1) : make_pair(LLONG_MIN, -1));
    }
    else if(ql <= l && r <= qr){
        return segmtree[t][node];
    }
    else{
        int m = (l + r) / 2;
        pair<ll, ll> q1 = qry(2 * node, l, m, ql, qr, t);
        pair<ll, ll> q2 = qry(2 * node + 1, m + 1, r, ql, qr, t);
        return (t == MIN ? min(q1, q2) : max(q1, q2));
    }
}

pair<ll, ll> qry(ll l, ll r, ll t){ return qry(1, 1, n, l, r, t); }

int main(){
    /// ios_base::sync_with_stdio(false); cin.tie(NULL);
    cin >> n;
    for(int i = 1; i <= n; i ++) cin >> A[i][0] >> A[i][1];
    build();
    ll ans = LLONG_MAX;
    /// L = 1
    for(int R = 1; R < n; R ++){
        ans = min(ans, (A[R][0] - A[1][0]) + (qry(R + 1, n, 1).fr - qry(R + 1, n, 0).fr));
    }
    /// L > 1
    for(int L = 2; L <= n; L ++){
        ll fr_max = qry(1, L - 1, MAX).fr;
        ll fr_min = qry(1, L - 1, MIN).fr;
        ll R = L;
        ll tmp = max(fr_max, qry(R + 1, n, MAX).fr) - min(fr_min, qry(R + 1, n, MIN).fr);
        while(R <= n){
            auto next_max = qry(R + 1, n, MAX);
            auto next_min = qry(R + 1, n, MIN);
            ll cand1 = LLONG_MAX, cand2 = LLONG_MAX;
            if(next_max.fr > fr_max)
                cand1 = next_max.sc;
            if(next_min.fr < fr_min)
                cand2 = next_min.sc;
            if(min(cand1, cand2) == LLONG_MAX)
                break;
            R = min(cand1, cand2);
            tmp = min(tmp, (A[R][0] - A[L][0]) + (max(fr_max, qry(R + 1, n, MAX).fr) - min(fr_min, qry(R + 1, n, MIN).fr)));
        }
        ans = min(ans, tmp);
    }
    cout << ans << endl;
}
/**
11
1 28
5 24
11 14
13 43
19 29
23 6
28 25
36 51
39 32
44 29
50 21
*/
